<?php
session_start();
/**
* Plugin Name: History Log by click5
* Plugin URI: https://www.click5interactive.com/wordpress-history-log-plugin/
* Description: Track user activity and log changes on your website.
* Version: 1.0.6
* Author: click5 Interactive
* Author URI: https://www.click5interactive.com/?utm_source=history-plugin&utm_medium=plugin-list&utm_campaign=wp-plugins
* Text Domain: history-log-by-click5
* Domain Path: /languages
* Tags: history, log, changes, activity, click5
**/
if ( ! function_exists( 'get_plugins' ) )
{
  require_once( ABSPATH . 'wp-includes/pluggable.php' );
}
require_once( ABSPATH . 'wp-includes/user.php');

if (!function_exists('is_plugin_active')) {
  include_once(ABSPATH . 'wp-admin/includes/plugin.php');
}


include("click5_grid.php");
include("click5_grid_plugins.php");
include("api.php");


define('click5_history_log_VERSION', '1.0.6');
define('click5_history_log_DEV_MODE', true);
define( 'CLICK5_HISTORY_LOG_PLUGIN_PATH', plugin_dir_path( __FILE__ ) );
global $click5_aioseo_options_old;


function click5_history_log_activate_plugin_name() {
  $role = get_role( 'editor' );
  $role->add_cap( 'manage_options' ); // capability
}
// Register our activation hook
register_activation_hook( __FILE__, 'click5_history_log_activate_plugin_name' );

function click5_history_log_deactivate_plugin_name() {

 $role = get_role( 'editor' );
 $role->remove_cap( 'manage_options' ); // capability
}

register_deactivation_hook( __FILE__, 'click5_history_log_deactivate_plugin_name' );

add_filter( 'wp_redirect',function($location,$status){
	ob_start();
	if((!is_null($_SESSION['cookie-filter-by-module']) && isset($_SESSION['cookie-filter-by-module']) != "all") || (!is_null($_SESSION['cookie-filter-by-user']) && isset($_SESSION['cookie-filter-by-user']) != "all") || (!is_null($_SESSION['cookie-filter-by-month']) && isset($_SESSION['cookie-filter-by-month']) != "0"))
		return $location;
	$params = parse_url($location,PHP_URL_QUERY);
	parse_str($params,$params);
	if(isset($params['page']) && isset($params['paged'])){
		if($params['page'] == "history-log-by-click5/history-log-by-click5.php"){
		  if(isset($_POST['paged']) && !is_null($_POST['paged']) && $_POST['paged'] != "")
			$pageparam = $_POST['paged'];
		  else if(isset($_GET['paged']) && !is_null($_GET['paged']) && $_GET['paged'] != "")
			$pageparam = $_GET['paged'];

      if(isset($_REQUEST['max_page'])){
        if($params['paged'] > $_REQUEST['max_page'])
          $params['paged'] = $_REQUEST['max_page'];
      }
		  $params = "paged=".$params['paged'];
		  $location = str_replace($params,"paged=".$pageparam,$location);
		  //$params = "?".http_build_query($params);
		  //$admin_url = substr(admin_url(),0,-1);
		  //$url = $admin_url.$params;
		  return $location;
		}
	}
	
	return $location;
  },10,2);

function click5_check_nonce_log($nonce){
  return wp_verify_nonce($nonce, 'click5_history_log_nonce');
}

add_action( 'init', 'click5_global_user_var' );
function click5_global_user_var()
{ 
  global $min_version_support_plugin_list;
  global $sitemapCurrentUser;
  $sitemapCurrentUser = wp_get_current_user();

  $min_version_support_plugin_list = array(
    "wordpress-seo/wp-seo.php" => "14.9",
    "wordpress-seo-premium/wp-seo-premium.php" => "14.9"
  );

  /*global $gCurrentUser;
  if(is_null($gCurrentUser))
    $gCurrentUser = wp_get_current_user()->data->user_login;*/

  if(esc_attr(get_option('click5_history_log_better-search-replace-pro/better-search-replace.php')) == "1"){
    if(isset($_REQUEST['page']))
    {
      if($_REQUEST['page'] == "better-search-replace"){
        global $gCurrentUser;
        global $sitemapCurrentUser;
        $usr = $gCurrentUser;
        if(is_null($gCurrentUser) && !is_null($sitemapCurrentUser->data->user_login))
          $usr = $sitemapCurrentUser->data->user_login;
        else if(is_null($gCurrentUser) && !is_null(wp_get_current_user()->data->user_login))
          $usr = wp_get_current_user()->data->user_login;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if(isset($_REQUEST['import']) && isset($_REQUEST['result'])){
          if($_REQUEST['import'] == "true" && $_REQUEST['result'] == "true"){
            $wpdb->insert($table_name, array('description'=>"<b>Database import</b> has ended",'date'=>date('Y-m-d H:i:s'), 'plugin'=>"Better Search Replace Pro", 'user'=>$usr));
  
          }
        }
      } 
    }
  }

  $theme_list = wp_get_themes();
  foreach($theme_list as $theme_item) {
    if (!get_option("version_theme_" . $theme_item->get('TextDomain'))) {
      add_option("version_theme_" . $theme_item->get('TextDomain'), $theme_item->get('Version'));
    }
  }
  if(function_exists('is_plugin_active')) {
    if( is_plugin_active("all-in-one-seo-pack/all_in_one_seo_pack.php") || is_plugin_active("all-in-one-seo-pack-pro/all_in_one_seo_pack.php") ) {
      global $click5_aioseo_options_old;
      if(isset(aioseo()->core->optionsCache))
      {
        $click5_aioseo_options_old = aioseo()->core->optionsCache->getOptions( "aioseo_options" );
      }
    }
}

  if(isset($_POST['save_button'])){ 
    $nonce = sanitize_text_field($_POST['click5_history_log_nonce']); 
    if(click5_check_nonce_log($nonce))
    {
      $confirm = sanitize_text_field($_POST["confirmDelete"]);
      if($confirm == 'delete' || $confirm == 'DELETE')
      {
        global $wpdb;
        global $gCurrentUser;
        $gCurrentUser = wp_get_current_user()->user_login;
        $table_name = $wpdb->prefix . "c5_history";
        $sql_clean_log = "DELETE FROM $table_name";
        $wpdb->query($sql_clean_log);
        if(esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") {
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data has been purged",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        }
        $url = home_url().'/wp-admin/admin.php?page=history-log-by-click5%2Fhistory-log-by-click5.php';
        header("Location:".$url);
        
        exit();
      }
      else if($confirm == '')
      {
        global $wpdb;
        global $gCurrentUser;
        $gCurrentUser = wp_get_current_user()->user_login;
        $table_name = $wpdb->prefix . "c5_history";
        $input = sanitize_text_field($_POST['click5_history_log_store_time']); 
        update_option("click5_log_store_time", $input);
        $date = new DateTime('now');
        if($input == 'indefinitely' && esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data storage duration has been changed to <b>indefinitely</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        }
        if($input == 'day' && esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") {
          $date->modify('+1 day');
          $date = $date->format('Y-m-d h:i A');
          update_option( 'click5_history_log_clear_date', $date);
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data storage duration has been changed to <b>1 day</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        }  
        if($input == 'week' && esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") {
          $date->modify('+7 days');
          $date = $date->format('Y-m-d h:i A');
          update_option( 'click5_history_log_clear_date', $date);
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data storage duration has been changed to <b>1 week</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        } 
        if($input == 'month' && esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") {
          $date->modify('+1 month');
          $date = $date->format('Y-m-d h:i A');
          update_option( 'click5_history_log_clear_date', $date);
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data storage duration has been changed to <b>1 month</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        } 
        if($input == '3_month' && esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") {
          $date->modify('+3 month');
          $date = $date->format('Y-m-d h:i A');
          update_option( 'click5_history_log_clear_date', $date);
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data storage duration has been changed to <b>3 months</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        } 
        if($input == '6_month' && esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") {
          $date->modify('+6 month');
          $date = $date->format('Y-m-d h:i A');
          update_option( 'click5_history_log_clear_date', $date);
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data storage duration has been changed to <b>6 months</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        } 
        if($input == '12_month' && esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") {
          $date->modify('+12 month');
          $date = $date->format('Y-m-d h:i A');
          update_option( 'click5_history_log_clear_date', $date);
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data storage duration has been changed to <b>12 months</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        } 
      }  
    }
  }

  if(isset($_POST['save_button_op']))
  { 
    $nonce = sanitize_text_field($_POST['click5_history_log_nonce']); 
    if(click5_check_nonce_log($nonce))
    {
      $confirm = sanitize_text_field($_POST["confirmDelete"]);
      if($confirm == 'delete' || $confirm == 'DELETE')
      {
        global $wpdb;
        global $gCurrentUser;
        $gCurrentUser = wp_get_current_user()->user_login;
        $table_name = $wpdb->prefix . "c5_history";
        $sql_clean_log = "DELETE FROM $table_name";
        $wpdb->query($sql_clean_log);
        if(esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>"<b>History Log</b> data has been purged",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>$gCurrentUser));
        }
        $url = home_url().'/wp-admin/admin.php?page=history-log-by-click5%2Fhistory-log-by-click5.php';
        header("Location:".$url);
        
        exit();
      }
    }
  }

  if ( ! function_exists( 'get_plugins' ) ) {      
    require_once ABSPATH . 'wp-admin/includes/plugin.php';
  }  

  global $wpdb;
  global $gCurrentUser;
  global $previous_plugins_list;
  $previous_plugins_list = get_plugins();
  $gCurrentUser = wp_get_current_user()->user_login;
  
  global $gBlockDouble;
  $gBlockDouble = false;
  global $gRepData;
  $gRepData = array(0, false);
  global $gRepEditDeleteData;
  $gRepEditDeleteData = array(0, "");
  global $gRepEditAddData;
  $gRepEditAddData = array(0, "");
  $support_plugin_list = array(
    "advanced-custom-fields/acf.php", 
    "acf-repeater/acf-repeater.php",
    "acf-extended/acf-extended.php", 
    "all-in-one-seo-pack/all_in_one_seo_pack.php",
    "all-in-one-seo-pack-pro/all_in_one_seo_pack.php",
    "classic-editor/classic-editor.php",
    "contact-form-7/wp-contact-form-7.php",
    "disable-comments-by-click5/disable-comments-by-click5.php",
    "history-log-by-click5/history-log-by-click5.php",
    "seo-by-rank-math/rank-math.php",
    "seo-by-rank-math-pro/rank-math-pro.php",
    "sitemap-by-click5/sitemap-by-click5.php",
    "wordfence/wordfence.php",
    "wordpress-seo/wp-seo.php",
    "wordpress-seo-premium/wp-seo-premium.php",
    "cf7-add-on-by-click5/cf7-addon-by-click5.php",
    "wpf-add-on-by-click5/wpf-addon-by-click5.php",
    "gf-add-on-by-click5/gf-addon-by-click5.php",
    "click5-crm-add-on-to-ninja-forms/ninja-addon-by-click5.php",
    "wpforms-lite/wpforms.php",
    "wpforms/wpforms.php",
    "ninja-forms/ninja-forms.php",
    "advanced-custom-fields-pro/acf.php",
    "better-search-replace/better-search-replace.php",
    "better-search-replace-pro/better-search-replace.php",
    "redirection/redirection.php"
  );
  foreach($support_plugin_list as $support_plugin_list_item) {
    $plug_exist = $wpdb->query( $wpdb->prepare( "SELECT * FROM " . $wpdb->prefix . "options WHERE option_name ='%s' LIMIT 1", 'click5_history_log_' . $support_plugin_list_item ));
    if($plug_exist){
      if(is_plugin_active($support_plugin_list_item))
        $plugin_version = get_plugin_data(WP_PLUGIN_DIR . '/' . $support_plugin_list_item)['Version'];
      else
        $plugin_version = null;
      if(!is_null($plugin_version) && isset($min_version_support_plugin_list[$support_plugin_list_item]))
      {
        if(version_compare($plugin_version,$min_version_support_plugin_list[$support_plugin_list_item]) < 1){
          if(isset($min_version_support_plugin_list[$support_plugin_list_item]))
            update_option("click5_history_log_".$support_plugin_list_item, "0");
        }
      }
    }
    else {
      add_option('click5_history_log_' . $support_plugin_list_item, "1");
    }
  }
}

add_filter( 'recovery_mode_email', function( $email ) {
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Your Site is Experiencing a Technical Issue (recovery_mode_email)",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>'WordPress Core'));
  return $email;
} );
add_filter( 'display_default_error_template', 'click5_error_catch', 10, 3 );
function click5_error_catch()
{
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Your Site is Experiencing a Technical Issue (display_default_error_template)",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>'WordPress Core'));
}
add_filter( 'wp_php_error_message', 'click5_error_catch2', 10, 3 );
function click5_error_catch2($message, $error)
{
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $err = substr_replace($error['message'],"",strpos($error['message'],"Stack trace"));
  $wpdb->insert($table_name, array('description'=>"Your Site is Experiencing a Technical Issue (wp_php_error_message)<br>$err",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>'WordPress Core'));
}

add_filter( 'cron_schedules', 'click5_add_every_minutes' );
function click5_add_every_minutes( $schedules ) {
    $schedules['every_interval'] = array(
            'interval' => 1800
    );
    return $schedules;
}

if ( ! wp_next_scheduled( 'click5_add_every_minutes' ) ) {
    wp_schedule_event( time(), 'every_interval', 'click5_add_every_minutes' );
}

add_action( 'click5_add_every_minutes', 'click5_clean_event_func' );
function click5_clean_event_func() {
  if(esc_attr(get_option('click5_log_store_time')) != 'indefinitely') {
    $date_now = new DateTime('now');
    $status_clean = esc_attr(get_option("click5_log_store_time"));
    if($status_clean == 'day') {
      $date_now->modify('-1 day');
      $date_now = $date_now->format('Y-m-d h:i A');
     // update_option( 'click5_history_log_clear_date', $date_now);
    }  
    if($status_clean == 'week') {
      $date_now->modify('-7 days');
      $date_now = $date_now->format('Y-m-d 23:59');
     // update_option( 'click5_history_log_clear_date', $date_now);
    } 
    if($status_clean == 'month') {
      $date_now->modify('-1 month');
      $date_now = $date_now->format('Y-m-d h:i A');
    //  update_option( 'click5_history_log_clear_date', $date_now);
    } 
    if($status_clean == '3_month') {
      $date_now->modify('-3 month');
      $date_now = $date_now->format('Y-m-d h:i A');
     // update_option( 'click5_history_log_clear_date', $date_now);
    } 
    if($status_clean == '6_month') {
      $date_now->modify('-6 month');
      $date_now = $date_now->format('Y-m-d h:i A');
     // update_option( 'click5_history_log_clear_date', $date_now);
    } 
    if($status_clean == '12_month') {
      $date_now->modify('-12 month');
      $date_now = $date_now->format('Y-m-d h:i A');
      //update_option( 'click5_history_log_clear_date', $date_now);
    } 
    
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
      $sql_clean_log = "DELETE FROM $table_name where date <= '$date_now'";
      $res = $wpdb->query($sql_clean_log);
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      if(esc_attr(get_option('click5_history_log_history-log-by-click5/history-log-by-click5.php')) == "1" && $res>0 ) {
        //Daily **History Log** data purge (X records deleted)
        if($res == 1)
        {
          $wpdb->insert($table_name, array('description'=>"Daily <b>History Log</b> data has been purged (".$res." record deleted)",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>'History Log by click5'));
        }
        else
        {
          $wpdb->insert($table_name, array('description'=>"Daily <b>History Log</b> data has been purged (".$res." records deleted)",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>'History Log by click5'));
        }
      }
      else
      {
        $date_from = date('Y-m-d 00:00:00');
        $date_to = date('Y-m-d 23:59:59');
        //$query = "SELECT * FROM $table_name where plugin =History Log by click5";
        $sql =" SELECT id FROM ". $table_name . " WHERE description like '%data has been purged (%' AND date >= '". $date_from . "' AND date <= '". $date_to . "' ";
        global $wpdb;
        $query =$wpdb->query($sql);
        if($query==0)
        {
         $wpdb->insert($table_name, array('description'=>"Daily <b>History Log</b> data has been purged (0 records deleted)",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'History Log by click5', 'user'=>'History Log by click5'));
        }
      }
  }
}

add_action('admin_menu', 'click5_history_log_create_menu');
function click5_history_log_create_menu() {
  $capability  = apply_filters( 'click5_history_log_required_capabilities', 'manage_options' );
  add_menu_page('History Log', 'History Log', $capability , __FILE__, 'click5_history_log_settings_page' , 'dashicons-editor-table');
  add_action( 'admin_init', 'click5_history_log_activation_redirect' );
}

function click5_history_log_activation_redirect( $plugin ) {
  if( $plugin == plugin_basename( __FILE__ ) ) {
      exit( wp_redirect( admin_url( 'admin.php?page=history-log-by-click5%2Fhistory-log-by-click5.php' ) ) );
  }
}

add_action( 'activated_plugin', 'click5_history_log_activation_redirect' );

add_filter('plugin_action_links_'.plugin_basename(__FILE__), 'click5_history_log_add_plugin_page_settings_link');
function click5_history_log_add_plugin_page_settings_link( $links ) {
  $links[] = '<a href="' .
  admin_url( 'admin.php?page=history-log-by-click5%2Fhistory-log-by-click5.php' ).
    '">' . __('Settings') . '</a>';
  return $links;
}

add_filter( 'plugin_row_meta', 'click5_history_log_plugin_meta', 10, 2 );
function click5_history_log_plugin_meta( $links, $file ) { 
	if ( strpos( $file, 'history-log-by-click5.php' ) !== false ) {
    array_splice( $links, 2, 0, array( '<a href="https://www.click5interactive.com/wordpress-history-log-plugin/?utm_source=history-plugin&utm_medium=plugin-list&utm_campaign=wp-plugins" target="_blank" rel="nofollow">About plugin</a>' ) );
	}
	return $links;
}

function click5_history_log_activation(){
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $db_version = '1.0.0';
    $charset_c = $wpdb->get_charset_collate();
    delete_option( 'click5_log_store_time' );
    delete_option( 'click5_history_log_clear_date' );
    add_option( 'click5_log_store_time', '6_month');
    $date = new DateTime('now');
    $date->modify('+6 month');
    $date = $date->format('Y-m-d h:i A');
    add_option( 'click5_history_log_clear_date', $date);

    $support_plugin_list = array(
    "advanced-custom-fields/acf.php",
    "acf-repeater/acf-repeater.php",
    "acf-extended/acf-extended.php", 
    "all-in-one-seo-pack/all_in_one_seo_pack.php",
    "all-in-one-seo-pack-pro/all_in_one_seo_pack.php",
    "classic-editor/classic-editor.php",
    "contact-form-7/wp-contact-form-7.php",
    "disable-comments-by-click5/disable-comments-by-click5.php",
    "history-log-by-click5/history-log-by-click5.php",
    "seo-by-rank-math/rank-math.php",
    "seo-by-rank-math-pro/rank-math-pro.php",
    "sitemap-by-click5/sitemap-by-click5.php",
    "wordfence/wordfence.php",
    "wordpress-seo/wp-seo.php",
    "wordpress-seo-premium/wp-seo-premium.php",
    "cf7-add-on-by-click5/cf7-addon-by-click5.php",
    "wpf-add-on-by-click5/wpf-addon-by-click5.php",
    "gf-add-on-by-click5/gf-addon-by-click5.php",
    "click5-crm-add-on-to-ninja-forms/ninja-addon-by-click5.php",
    "wpforms-lite/wpforms.php",
    "wpforms/wpforms.php",
    "ninja-forms/ninja-forms.php",
    "advanced-custom-fields-pro/acf.php",
    "better-search-replace/better-search-replace.php",
    "better-search-replace-pro/better-search-replace.php",
    "redirection/redirection.php"
    );
    foreach($support_plugin_list as $support_plugin_list_item) {
      delete_option('click5_history_log_' . $support_plugin_list_item);
      add_option('click5_history_log_' . $support_plugin_list_item, "1");
    }
    
    if ( $wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name ) {

        $sql = "CREATE TABLE $table_name (
                ID mediumint(9) NOT NULL AUTO_INCREMENT,
                `description` text NOT NULL,
                `user` text NOT NULL,
                `plugin` text NOT NULL,
                `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
                PRIMARY KEY  (ID)
        ) $charset_c;";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
        add_option('my_db_version', $db_version);
    }
}
register_activation_hook( __FILE__, 'click5_history_log_activation' );

add_action('_core_updated_successfully', 'click5_core_updated_successfully');
function click5_core_updated_successfully($data) {
  global $wpdb;
  global $gCurrentUser;
  global $pagenow;
  $table_name = $wpdb->prefix . "c5_history";
  if('update-core.php' == $pagenow) {
    $wpdb->insert($table_name, array('description'=>"<b>WordPress</b> has been updated from version " . $GLOBALS['wp_version'] . " to <b>" . $data . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  } else {
    $wpdb->insert($table_name, array('description'=>"<b>WordPress</b> has been auto-updated from version " . $GLOBALS['wp_version'] . " to <b>" . $data . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>"WordPress Core"));
  }
}

add_action('after_switch_theme', 'click5_after_switch_theme');
function click5_after_switch_theme($data) {
  global $wpdb;
  global $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Theme <b>" . $data . "</b> has been deactivated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Themes', 'user'=>$gCurrentUser));
}

add_action('switch_theme', 'click5_switch_theme');
function click5_switch_theme($data) {
  global $wpdb;
  global $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Theme <b>" . $data . "</b> has been activated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Themes', 'user'=>$gCurrentUser));
}

add_action('delete_theme', 'click5_delete_theme');
function click5_delete_theme($data) {
  global $wpdb;
  global $gCurrentUser;
  $theme_data = wp_get_theme($data);
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Theme <b>" . $theme_data->get('Name') . "</b> has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Themes', 'user'=>$gCurrentUser));
}

add_action('wp_create_nav_menu', 'click5_wp_create_nav_menu', 10, 2);
function click5_wp_create_nav_menu($id, $data) {
  global $wpdb;
  global $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Menu <b>" . $data['menu-name'] . "</b> has been created",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Menu', 'user'=>$gCurrentUser));
}

add_action('wp_update_nav_menu', 'click5_wp_update_nav_menu', 10, 2);
function click5_wp_update_nav_menu($info, $data = NULL) {
  if($data != null) {
    global $wpdb;
    global $gCurrentUser;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>"Menu <b>" . $data['menu-name'] . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Menu', 'user'=>$gCurrentUser));
  }
}

add_action('delete_nav_menu', 'click5_delete_nav_menu', 10, 3);
function click5_delete_nav_menu($id, $info, $data) {
  global $wpdb;
  global $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Menu <b>" . $data->name . "</b> has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Menu', 'user'=>$gCurrentUser));
}

add_action( 'activated_plugin', function($plugin){ 
  $info = get_plugin_data(WP_PLUGIN_DIR . '/' . $plugin);
  $name_plugin = $info['Name'];
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  if($name_plugin != "" && $name_plugin != " " && $name_plugin != null) {
    $wpdb->insert($table_name, array('description'=>"<b>" . $name_plugin . "</b> plugin has been activated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
  } 
});

add_action( 'deactivated_plugin', function($plugin){ 
  $info = get_plugin_data(WP_PLUGIN_DIR . '/' . $plugin);
  $name_plugin = $info['Name'];
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history"; 
  if($name_plugin != "" && $name_plugin != " " && $name_plugin != null) { 
    $wpdb->insert($table_name, array('description'=>"<b>" . $name_plugin . "</b> plugin has been deactivated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
  }
});

add_action( 'delete_plugin', function($plugin){ 
  $info = get_plugin_data(WP_PLUGIN_DIR . '/' . $plugin);
  $name_plugin = $info['Name'];
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history"; 
  if($name_plugin != "" && $name_plugin != " " && $name_plugin != null) { 
    $wpdb->insert($table_name, array('description'=>"<b>" . $name_plugin . "</b> plugin has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
  }
});


add_action('upgrader_process_complete', 'click5_after_plugin_install', 10, 2);
function click5_after_plugin_install($plugin_upgrader_instance, $arr_data)
{
  if (isset($arr_data['type']) && 'translation' == $arr_data['type'] && 'update' == $arr_data['action'] && $arr_data['translations'][0]["type"]=="core") { 
    require_once ABSPATH . 'wp-admin/includes/translation-install.php';
    $lang_name = $arr_data['translations'][0]["language"];
    $translations = wp_get_available_translations();  
    foreach($translations as $translation_item) {
      if($translation_item["language"] == $arr_data['translations'][0]["language"]) {
        $lang_name = $translation_item["english_name"];
      }
    }
    global $wpdb;
    global $gCurrentUser;
    $table_name = $wpdb->prefix . "c5_history";
    //$wpdb->insert($table_name, array('description'=>"<b>Translation</b> for <b>" . $lang_name . "</b> language has been updated to version <b>" . $arr_data['translations'][0]["version"] . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }
  if (isset($arr_data['type']) && 'theme' == $arr_data['type'] && 'install' == $arr_data['action']) { 
    global $wpdb;
    global $gCurrentUser;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>"Theme <b>" . $plugin_upgrader_instance->new_theme_data["Name"] . "</b> has been installed",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Themes', 'user'=>$gCurrentUser));
  }
  if (isset($arr_data['type']) && 'theme' == $arr_data['type'] && 'update' == $arr_data['action']) { 
    global $wpdb;
    global $gCurrentUser;
    $theme_data = wp_get_theme($arr_data['themes'][0]);
    $h = $theme_data->get("headers");
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>"Theme <b>" . $theme_data->get('Name') . "</b> has been updated from version " . get_option("version_theme_" . $theme_data->get('TextDomain')) .  " to <b>" . $theme_data->get('Version') . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Themes', 'user'=>$gCurrentUser));
    update_option("version_theme_" . $theme_data->get('TextDomain'), $theme_data->get('Version'));
  }
  if (isset($arr_data['type']) && 'plugin' == $arr_data['type']) {
    if (isset($arr_data['action']) && 'install' == $arr_data['action'] && ! $plugin_upgrader_instance->bulk) {
      $upgrader_skin_options = isset($plugin_upgrader_instance->skin->options) && is_array($plugin_upgrader_instance->skin->options) ? $plugin_upgrader_instance->skin->options : array();
      $upgrader_skin_result  = isset($plugin_upgrader_instance->skin->result) && is_array($plugin_upgrader_instance->skin->result) ? $plugin_upgrader_instance->skin->result : array();
      $upgrader_skin_api     = isset($plugin_upgrader_instance->skin->api) ? $plugin_upgrader_instance->skin->api : (object) array();
      $plugin_slug = isset($upgrader_skin_result['destination_name']) ? $upgrader_skin_result['destination_name'] : '';
      $plug_list = get_plugins();
      foreach($plug_list as $single_plug){
        if($plugin_slug == $single_plug['TextDomain']) {
          global $wpdb;
          $table_name = $wpdb->prefix . "c5_history"; 
          $wpdb->insert($table_name, array('description'=>"<b>" . $single_plug['Name'] . "</b> plugin has been installed",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
        }
      }
    }
    if(isset($arr_data['action']) && 'update' == $arr_data['action']) {
      $upgrader_skin_options = isset($plugin_upgrader_instance->skin->options) && is_array($plugin_upgrader_instance->skin->options) ? $plugin_upgrader_instance->skin->options : array();
      $upgrader_skin_result  = isset($plugin_upgrader_instance->skin->result) && is_array($plugin_upgrader_instance->skin->result) ? $plugin_upgrader_instance->skin->result : array();
      $upgrader_skin_api     = isset($plugin_upgrader_instance->skin->api) ? $plugin_upgrader_instance->skin->api : (object) array();
      $plugin_slug = isset($upgrader_skin_result['destination_name']) ? $upgrader_skin_result['destination_name'] : '';
      $plug_list = get_plugins();
      foreach($plug_list as $single_plug){
        if($plugin_slug == $single_plug['TextDomain']) {
          global $wpdb;
          global $previous_plugins_list;
          foreach($previous_plugins_list as $key => $previous_plugin_item) {
            if(strpos($key, $single_plug['TextDomain']) !== false){ 
              $old_version = $previous_plugin_item['Version'];
            }
          }
          $table_name = $wpdb->prefix . "c5_history"; 
          $wpdb->insert($table_name, array('description'=>"<b>" . $single_plug['Name'] . "</b> plugin has been updated from version " . $old_version . " to <b>" . $single_plug['Version'] . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
        }
        if($plugin_slug == "advanced-custom-fields" && $single_plug['TextDomain'] == "acf") {
          global $wpdb;
          global $previous_plugins_list;
          foreach($previous_plugins_list as $key => $previous_plugin_item) {
            if($key != "acf-repeater/acf-repeater.php" && strpos($key, $single_plug['TextDomain']) !== false){ 
              $old_version = $previous_plugin_item['Version'];
            }
          }
          $table_name = $wpdb->prefix . "c5_history"; 
          $wpdb->insert($table_name, array('description'=>"<b>" . $single_plug['Name'] . "</b> plugin has been updated from version " . $old_version . " to <b>" . $single_plug['Version'] . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
        }
      }
    }
  }
}

add_action( 'register_activation_hook', function($plugin){ 
  global $wpdb;
});

$option = 'auto_update_plugins';

add_filter("update_option_{$option}", function ($val1, $val2, $option) {
  if($option == 'auto_update_plugins') {
    $v1 = count($val1);
    $v2 = count($val2);
    if($v2 > $v1) {
      foreach($val2 as $v) {
        $flag = false;
        foreach($val1 as $y) {
          if($v == $y) {
            $flag = true;
          }
        }
        if(!$flag) {
          $info = get_plugin_data(WP_PLUGIN_DIR . '/' . $v);
          $name_plugin = $info['Name'];
          global $wpdb;
          $table_name = $wpdb->prefix . "c5_history"; 
          if($name_plugin != "" && $name_plugin != " " && $name_plugin != null) { 
            $wpdb->insert($table_name, array('description'=>"<b>" . $name_plugin . "</b> plugin auto update has been enabled",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));      
          }
        }
      }
    }
    if($v1 > $v2) {
      foreach($val1 as $v) {
        $flag = false;
        foreach($val2 as $y) {
          if($v == $y) {
            $flag = true;
          }
        }
        if(!$flag) {
          $info = get_plugin_data(WP_PLUGIN_DIR . '/' . $v);
          $name_plugin = $info['Name'];
          global $wpdb;
          $table_name = $wpdb->prefix . "c5_history"; 
          if($name_plugin != "" && $name_plugin != " " && $name_plugin != null) { 
            $wpdb->insert($table_name, array('description'=>"<b>" . $name_plugin . "</b> plugin auto update has been disabled",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
          }        
        }
      }
    }
  }
}, 10, 3);


add_action( 'automatic_updates_complete', 'click5_automatic_updates_complete' );
function click5_automatic_updates_complete( $results ) {
    // the list of plugins is contained within the "plugins" attribute
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($results["translation"][0]->name == "Translations for WordPress") {
      require_once ABSPATH . 'wp-admin/includes/translation-install.php';
      $lang_name = $results["translation"][0]->item->language;
      $translations = wp_get_available_translations();  
      foreach($translations as $translation_item) {
        if($translation_item["language"] ==  $results["translation"][0]->item->language) {
          $lang_name = $translation_item["english_name"];
        }
      }
      //$wpdb->insert($table_name, array('description'=>"<b>Translation</b> for <b>" . $lang_name . "</b> language has been auto-updated to version <b>" .  $results["translation"][0]->item->version . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>'WordPress Core'));
    } 
    foreach ( $results['plugin'] as $plugin ) {
        // make sure the plugin slug matches the one assigned to your own plugin
        if ( ! empty( $plugin->name )) {
            if($plugin->result)
            {
              $wpdb->insert($table_name, array('description'=>"<b>" . $plugin->name . "</b> plugin has been auto-updated from version " . $plugin->item->current_version . " to <b>" . $plugin->item->new_version . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>'WordPress Core'));
            }
        }
    }

    foreach ( $results['theme'] as $theme ) {
      // make sure the plugin slug matches the one assigned to your own plugin
      if ( ! empty( $theme->name )) {
          if($theme->result)
          {
            $wpdb->insert($table_name, array('description'=>"<b>" . $theme->name . "</b> theme has been auto-updated from version " . $theme->item->current_version . " to <b>" . $theme->item->new_version . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Themes', 'user'=>'WordPress Core'));
          }
      }
   }
}



add_action( 'user_register', 'click5_registration_save', 10, 1 );
function click5_registration_save( $user_id ) {
  $user_data = get_userdata( $user_id );
  //$user_meta = get_usermeta($user_id);
  global $wpdb;
  $first_name = $_POST['first_name'];
  $last_name = $_POST['last_name'];
  $tab_name = $wpdb->base_prefix . 'users';
  $table_name = $wpdb->prefix . "c5_history";
  $user_login = "";
  $isAdded = false;
  $userDetails = "";
  $userRole = "";

  $user_login =wp_get_current_user()->user_login;
  if(wp_get_current_user()->user_login!=false)
  {
    $isAdded = true;
    $user_login =wp_get_current_user()->user_login;
  }
  else
  {
    $user_login = $user_data->data->user_login; //'WordPress Core';
  }


  if($first_name != "" && $last_name != "")
  {
    $userDetails = $first_name . " " .$last_name;
  }
  else
  {
    $userDetails =$user_data->data->display_name;
  }

  
  if (isset($user_data->roles)) 
  {
    if(count($user_data->roles)>0)
    {
      $userRole = $user_data->roles[0];
      global $wp_roles;
      $userRole = array_values((array)$wp_roles->roles[$userRole]['name'])[0];
      if(function_exists("ucfirst"))
      {
        $userRole = ucfirst($userRole);
      }
      $userRole = "(". $userRole . ")";
    }
  }

  if($isAdded)
  {
    $wpdb->insert($table_name, array('description'=>"New User <b>" . $userDetails . "</b> " .$userRole. " has been added to this site",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Users', 'user'=>$user_login));
  }
  else
  {
    $wpdb->insert($table_name, array('description'=>"New User <b>" . $userDetails . "</b> " .$userRole. " has registered",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$user_login));
  }
}


add_action( 'publish_page', 'click5_publish_page' );
function click5_publish_page($postid) {
  global $gCurrentUser;
  global $wpdb;
  $post_data = get_post($postid);
  $table_name = $wpdb->prefix . "c5_history";
  if($post_data->post_type == "post") {
    if($post_data->post_date == $post_data->post_modified) {
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    } else {
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    }
  }
  if($post_data->post_type == "page") {
    if($post_data->post_date == $post_data->post_modified) {
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    } else {
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    }
  }
}

add_action( 'publish_post', 'click5_publish_post' );
function click5_publish_post($postid) {
  global $gCurrentUser;
  global $wpdb;
  $post_data = get_post($postid);
  $table_name = $wpdb->prefix . "c5_history";
  if($post_data->post_type == "post") {
    if($post_data->post_date == $post_data->post_modified) {
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    } else {
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    }
  }
  if($post_data->post_type == "page") {
    if($post_data->post_date == $post_data->post_modified) {
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    } else {
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    }
  }
}

add_action( 'updated_post_meta', 'click5_meta_update_acf_repeater', 10, 4 );

function click5_meta_update_acf_repeater( $post, $p_id, $meta, $data ) {
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $valid_data = array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  foreach($valid_data as $valid_item) {
    if($valid_item === $data) {
      $post_data = get_post($p_id);

      $post_singularName = $post_data->post_type;
      $post_to_check = get_post_type_object( $post_data->post_type );
      if(isset($post_to_check->labels))
      {
        if(!is_null($post_to_check->labels) || $post_to_check->labels != "")
        {
          $post_singularName = $post_to_check->labels->singular_name;
          if(isset($post_singularName))
          {
            if(is_null($post_singularName) || $post_singularName == "") 
              $post_singularName = $post_data->post_type;
          }else{
            $post_singularName = $post_data->post_type;
          }
        }
      }

      global $gRepEditDeleteData;
      global $gRepEditAddData;
      $times = "times";
      $repeaters = "repeaters";
      if($data == 1) {
        $repeaters = "repeater";
      }
      if($gRepEditDeleteData[0] > 0 && $gRepEditAddData[0] > 0) {
        if(esc_attr(get_option('click5_history_log_acf-extended/acf-extended.php')) == "1") {  
          $wpdb->insert($table_name, array('description'=>"<b>" . $meta . "</b> repeater has been addeded <b>" . $gRepEditAddData[0] . " more times</b> and deleted <b>" . $gRepEditDeleteData[0] . " times</b> in " . $post_singularName . " " . $post_data->post_title . " and now this " . $post_singularName . " contains " . $data . " repeater",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'ACF Repeater', 'user'=>$gCurrentUser));
        }
        $gRepEditDeleteData = array(0, "");
        $gRepEditAddData = array(0, "");
      } elseif($gRepEditDeleteData[0] > 0) {
        $repeaters_del = "repeaters";
        if($gRepEditDeleteData[0] == 1) {
          $repeaters_del = "repeater";
        }
        if(esc_attr(get_option('click5_history_log_acf-extended/acf-extended.php')) == "1") {  
          $wpdb->insert($table_name, array('description'=> $gRepEditDeleteData[0] ." <b>" . $meta . "</b> " . $repeaters_del . " has been deleted from " . $post_singularName . " <b>" . $post_data->post_title . "</b> and now this " . $post_singularName . " contains " . $data . " " . $repeaters,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'ACF Repeater', 'user'=>$gCurrentUser));
        }
        $gRepEditDeleteData = array(0, "");
      } elseif($gRepEditAddData[0] > 0) {
        if($gRepEditAddData[0] == 1) {
          $times = "time";
        }
        if(esc_attr(get_option('click5_history_log_acf-extended/acf-extended.php')) == "1") {  
          $wpdb->insert($table_name, array('description'=>"<b>" . $meta . "</b> repeater has been addeded " . $gRepEditAddData[0] . " more " . $times . " in " . $post_singularName . " <b>" . $post_data->post_title . "</b> and now this " . $post_singularName . " contains " . $data . " " . $repeaters,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'ACF Repeater', 'user'=>$gCurrentUser));
        }
        $gRepEditAddData = array(0, "");
      } 
    }
  }
  if($data == "") {
    global $gRepEditDeleteData;
    $post_data = get_post($p_id);

    $post_singularName = $post_data->post_type;
    $post_to_check = get_post_type_object( $post_data->post_type );
    if(isset($post_to_check->labels))
    {
      if(!is_null($post_to_check->labels) || $post_to_check->labels != "")
      {
        $post_singularName = $post_to_check->labels->singular_name;
        if(isset($post_singularName))
        {
          if(is_null($post_singularName) || $post_singularName == "") 
            $post_singularName = $post_data->post_type;
        }else{
          $post_singularName = $post_data->post_type;
        }
      }
    }

    if($gRepEditDeleteData[0] > 0) {
      $repeaters_del = "repeaters";
      if($gRepEditDeleteData[0] == 1) {
        $repeaters_del = "repeater";
      }
      if(esc_attr(get_option('click5_history_log_acf-extended/acf-extended.php')) == "1") {  

      }
      $wpdb->insert($table_name, array('description'=>$gRepEditDeleteData[0] ." <b>" . $meta . "</b> " . $repeaters_del . " has been deleted from " . $post_singularName . " <b>" . $post_data->post_title . "</b> and now this " . $post_singularName . " doesn't contain any reapters",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'ACF Repeater', 'user'=>$gCurrentUser));
      $gRepEditDeleteData = array(0, "");
    }
  }
}

add_action( 'deleted_post_meta', 'click5_meta_deleted_acf_repeater', 10, 4 );

function click5_meta_deleted_acf_repeater( $post, $p_id, $meta, $data ) {
  global $gCurrentUser;
  global $wpdb;
  global $gRepEditDeleteData;
  $table_name = $wpdb->prefix . "c5_history";
  $check_data = array('_0_', '_1_', '_2_', '_3_', '_4_', '_5_', '_6_', '_7_', '_8_', '_9_', '_10_');
  foreach($check_data as $data_item) {
    if(strpos($meta, $data_item) !== false && $meta[0] != "_" && $gRepEditDeleteData[1] != $data_item) {
      $counter_delete = $gRepEditDeleteData[0];
      $gRepEditDeleteData = array($counter_delete + 1, $data_item);
    }
  }
}


add_action( 'added_post_meta', 'click5_meta_acf_repeater', 10, 4 );

function click5_meta_acf_repeater( $post, $p_id, $meta, $data ) {
  global $gCurrentUser;
  global $wpdb;
  global $gRepData;
  $table_name = $wpdb->prefix . "c5_history";
  global $gRepEditAddData;
  $check_data = array('_0_', '_1_', '_2_', '_3_', '_4_', '_5_', '_6_', '_7_', '_8_', '_9_', '_10_');
  foreach($check_data as $data_item) {
    if(strpos($meta, $data_item) !== false && $meta[0] != "_" && $gRepEditAddData[1] != $data_item) {
      $counter_add = $gRepEditAddData[0];
      $gRepEditAddData = array($counter_add + 1, $data_item);
    }
  }

  if($gRepData[1] == false && strpos($meta, '_0_') !== false && $meta[0] != "_") {
    $gRepData = array(1, true);
  } else {
    if($gRepData[1] == true) {
      if($gRepData[0] == $data) {
        $post_data = get_post($p_id);

        $post_singularName = $post_data->post_type;
        $post_to_check = get_post_type_object( $post_data->post_type );
        if(isset($post_to_check->labels))
        {
          if(!is_null($post_to_check->labels) || $post_to_check->labels != "")
          {
            $post_singularName = $post_to_check->labels->singular_name;
            if(isset($post_singularName))
            {
              if(is_null($post_singularName) || $post_singularName == "") 
                $post_singularName = $post_data->post_type;
            }else{
              $post_singularName = $post_data->post_type;
            }
          }
        }

        if($data==1)
        {
          if(esc_attr(get_option('click5_history_log_acf-extended/acf-extended.php')) == "1") { 
            $wpdb->insert($table_name, array('description'=>"<b>" . $meta . "</b> repeater has been used <b>" . $data . " time</b> in " . $post_singularName . "<b>" . $post_data->post_title."</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'ACF Repeater', 'user'=>$gCurrentUser));
          }
        }
        else
        {
          if(esc_attr(get_option('click5_history_log_acf-extended/acf-extended.php')) == "1") { 
            $wpdb->insert($table_name, array('description'=>"<b>" . $meta . "</b> repeater has been used <b>" . $data . " times</b> in " . $post_singularName . "<b>" . $post_data->post_title."</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'ACF Repeater', 'user'=>$gCurrentUser));
          }
        }
        $gRepData = array(0, false);
      } else if(strpos($meta, '_' . $gRepData[0] . '_') !== false && $meta[0] != "_") {
        $count = $gRepData[0];
        $gRepData = array($count + 1, true);
      }
    }
  }
}


add_action('transition_comment_status', 'click5_approve_comment', 10, 3);
function click5_approve_comment($new_status, $old_status, $comment) {
  if($old_status != $new_status) {
      if($new_status == 'approved' && $old_status != "trash" && $old_status != "spam") {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>"Comment by" . " <b>" . $comment->comment_author . "</b> has been approved",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Comments', 'user'=>$gCurrentUser));
      }
  }
  if($old_status != $new_status) {
    if($new_status == 'unapproved' && $old_status != "trash" && $old_status != "spam") {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>"Comment by" . " <b>" . $comment->comment_author . "</b> has been unapproved",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Comments', 'user'=>$gCurrentUser));
    }
  }
  if($old_status != $new_status) {
    if(($new_status == 'approved' || $new_status == 'unapproved') && $old_status == "spam") {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>"Comment by" . " <b>" . $comment->comment_author . "</b> has been unmarked as spam",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Comments', 'user'=>$gCurrentUser));
    }
  }
}

add_action( 'spam_comment', 'click5_spam_comment', 10, 2 );
function click5_spam_comment($comment_id, $comment) { 
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Comment by" . " <b>" . $comment->comment_author . "</b> has been marked as spam",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Comments', 'user'=>$gCurrentUser));
}

add_action( 'untrashed_comment', 'click5_untrashed_comment', 10, 2 );
function click5_untrashed_comment($comment_id, $comment) { 
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Comment by" . " <b>" . $comment->comment_author . "</b> has been restored from Trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Comments', 'user'=>$gCurrentUser));
}

add_action( 'trash_comment', 'click5_trash_comment', 10, 2 );
function click5_trash_comment($comment_id, $comment) { 
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Comment by" . " <b>" . $comment->comment_author . "</b> has been moved to the Trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Comments', 'user'=>$gCurrentUser));
}

add_action( 'delete_comment', 'click5_delete_comment', 10, 2 );
function click5_delete_comment($comment_id, $comment) { 
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Comment by" . " <b>" . $comment->comment_author . "</b> has been deleted pemanently",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Comments', 'user'=>$gCurrentUser));
}

add_action( 'add_attachment', 'click5_add_media_post' );
function click5_add_media_post($postid) { 
  global $gCurrentUser;
  global $wpdb;
  $post_data = get_post($postid);
  $file_type = explode("/", $post_data->post_mime_type)[1];
  if($file_type == "msword") {
    $file_type = "doc";
  }
  if($file_type == "vnd.ms-excel") {
    $file_type = "xls";
  }
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Media file" . " <b>" . $post_data->post_title . "." . $file_type . "</b> has been uploaded",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Media', 'user'=>$gCurrentUser));
}

add_action( 'edit_attachment', 'click5_edit_media_post' );
function click5_edit_media_post($postid) { 
  global $gCurrentUser;
  global $wpdb;
  $post_data = get_post($postid);
  $file_type = explode("/", $post_data->post_mime_type)[1];
  if($file_type == "msword") {
    $file_type = "doc";
  }
  if($file_type == "vnd.ms-excel") {
    $file_type = "xls";
  }
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"Media file" . " <b>" . $post_data->post_title . "." . $file_type . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Media', 'user'=>$gCurrentUser));
}

if(esc_attr(get_option('click5_history_log_ninja-forms/ninja-forms.php')) == "1")
{
    add_filter('wp_ajax_nf_save_form','click5_nf_save_form',1,2);
    function click5_nf_save_form(  )
    {
      global $wpdb;
      global $gCurrentUser;
      $table_name = $wpdb->prefix . "c5_history";
      $nforms = json_decode(sanitize_text_field(str_replace("\\","",$_REQUEST['form'])));
      $title = $nforms->settings->title;
      if(str_contains( $nforms->id, 'tmp' ))
        $wpdb->insert($table_name, array('description'=>"Form <b>" . $title . "</b> has been added",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Ninja Forms', 'user'=>$gCurrentUser));
      else
        $wpdb->insert($table_name, array('description'=>"Form <b>" . $title . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Ninja Forms', 'user'=>$gCurrentUser));
    }

    {
      add_filter('ninja_forms_after_form_delete','click5_nf_delete_form',1,2);
      function click5_nf_delete_form(  )
      {
        global $wpdb;
        global $gCurrentUser;
        $table_name = $wpdb->prefix . "c5_history";
        $nforms = Ninja_Forms()->form(intval($_REQUEST['form_id']))->get();
        $title = $nforms->get_settings()['title'];
        $wpdb->insert($table_name, array('description'=>"Form <b>" . $title . "</b> has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Ninja Forms', 'user'=>$gCurrentUser));
      }

      add_filter('ninja_forms_excluded_duplicate_form_settings','click5_nf_nf_duplicate',1,2);
      function click5_nf_nf_duplicate( $blacklist )
      {
        global $wpdb;
        global $gCurrentUser;
        $table_name = $wpdb->prefix . "c5_history";
        $nforms = Ninja_Forms()->form(intval($_REQUEST['clone_id']))->get();
        $title = $nforms->get_settings()['title'];
        $wpdb->insert($table_name, array('description'=>"Form <b>" . $title . "</b> has been duplicated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Ninja Forms', 'user'=>$gCurrentUser));
        return $blacklist;
      }
    }

  add_action( 'init', 'click5_nf_nf_add_new', 10,1 );
  function click5_nf_nf_add_new(  ){
    //setcookie("nf_batch_process",false);
    if(isset($_REQUEST['action'])){
      if($_REQUEST['action'] == 'nf_batch_process')
      setcookie("nf_batch_process",true);
    }

      if(isset($_COOKIE['nf_batch_process'])){
        if($_COOKIE['nf_batch_process'] == true)
        {
        if(isset($_REQUEST['form_id']) && isset($_REQUEST['page']))
        {
          if($_REQUEST['form_id'] != "new" && $_REQUEST['page'] == "ninja-forms")
          {
            //unset($_COOKIE['nf_batch_process']);
            setcookie("nf_batch_process",false);
            global $wpdb;
            global $gCurrentUser;
            $table_name = $wpdb->prefix . "c5_history";
            $nforms = Ninja_Forms()->form(intval($_REQUEST['form_id']))->get();
            $title = $nforms->get_settings()['title'];
            if(!isset($title) || $title == "")
              $title = "Blank";
            $wpdb->insert($table_name, array('description'=>"Form <b>" . $title . "</b> has been added",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Ninja Forms', 'user'=>$gCurrentUser));
          }
        }
      }
      } 
  }
}

add_action('bsr_ajax_process_search_replace','click5_bsr_search_process',10);

function click5_bsr_search_process(){
  if((esc_attr(get_option('click5_history_log_better-search-replace/better-search-replace.php')) == "1" && is_plugin_active('better-search-replace/better-search-replace.php')) || (esc_attr(get_option('click5_history_log_better-search-replace-pro/better-search-replace.php')) == "1" && is_plugin_active('better-search-replace-pro/better-search-replace.php'))){
    global $gCurrentUser;

    global $gCurrentUser;
  if(is_null($gCurrentUser))
    $gCurrentUser = wp_get_current_user()->data->user_login;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";

    $query_data = parse_url("?".$_REQUEST['bsr_data']);
    $params = "";
    parse_str($query_data['query'],$params);
    $tables = "";

    if(is_array($params))
    {
      if(is_array($params['select_tables'])){
        foreach($params['select_tables'] as $table){
          $tables .=",".$table;
        }

        $tables = substr($tables,1);
      }
    }
    $pro = "";
    if(is_plugin_active('better-search-replace-pro/better-search-replace.php'))
      $pro = "Pro";


    if($params['dry_run'] == "on"){
      if(!is_null($params['completed_pages']) && !is_null($params['total_pages']))
      {
        if($params['completed_pages'] == $params['total_pages'])
          $wpdb->insert($table_name, array('description'=>"Record <b>\"".esc_html($params['search_for'])."\"</b> has been searched in ".$tables,'date'=>date('Y-m-d H:i:s'), 'plugin'=>"Better Search Replace ".$pro, 'user'=>$gCurrentUser));
      }
      
    }else{
      if(!is_null($params['completed_pages']) && !is_null($params['total_pages']))
      {
        if($params['completed_pages'] == $params['total_pages']){
          $bsr_updates = get_transient( 'bsr_results' );
          if($bsr_updates['updates'] > 0)
            $wpdb->insert($table_name, array('description'=>"Record <b>\"".esc_html($params['search_for'])."\"</b> has been replaced with <b>\"".esc_html($params['replace_with'])."\"</b> in ".$tables,'date'=>date('Y-m-d H:i:s'), 'plugin'=>"Better Search Replace ".$pro, 'user'=>$gCurrentUser));
        }
          
      }
    }
  }
}
add_action('bsr_ajax_process_backup','click5_bsr_backup_database',10);
function click5_bsr_backup_database(){
  if(esc_attr(get_option('click5_history_log_better-search-replace-pro/better-search-replace.php')) == "1"){
    global $gCurrentUser;
    global $sitemapCurrentUser;
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser) && !is_null($sitemapCurrentUser->data->user_login))
        $usr = $sitemapCurrentUser->data->user_login;
    else if(is_null($gCurrentUser) && !is_null(wp_get_current_user()->data->user_login))
        $usr = wp_get_current_user()->data->user_login;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";

    if(isset($_REQUEST['bsr_step'])){
      if($_REQUEST['bsr_step'] == "1"){
        $wpdb->insert($table_name, array('description'=>"<b>Database backup</b> has started",'date'=>date('Y-m-d H:i:s'), 'plugin'=>"Better Search Replace Pro", 'user'=>$usr));
      }
    }
  }
}

add_action('bsr_ajax_process_import','click5_bsr_import_database',10);
function click5_bsr_import_database(){
  if(esc_attr(get_option('click5_history_log_better-search-replace-pro/better-search-replace.php')) == "1"){
    global $gCurrentUser;
    global $sitemapCurrentUser;
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser) && !is_null($sitemapCurrentUser->data->user_login))
      $usr = $sitemapCurrentUser->data->user_login;
    else if(is_null($gCurrentUser) && !is_null(wp_get_current_user()->data->user_login))
      $usr = wp_get_current_user()->data->user_login;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";

    if(isset($_REQUEST['bsr_step']) && isset($_REQUEST['bsr_page'])){
      if($_REQUEST['bsr_step'] == "0" && $_REQUEST['bsr_page'] == "0"){
        $wpdb->insert($table_name, array('description'=>"<b>Database import</b> has started",'date'=>date('Y-m-d H:i:s'), 'plugin'=>"Better Search Replace Pro", 'user'=>$usr));
      }
    }


  }
}

add_action('admin_post_bsr_download_backup','click5_bsr_backup_end',10);
function click5_bsr_backup_end(){
  if(esc_attr(get_option('click5_history_log_better-search-replace-pro/better-search-replace.php')) == "1"){
    global $gCurrentUser;
    global $sitemapCurrentUser;
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser) && !is_null($sitemapCurrentUser->data->user_login))
      $usr = $sitemapCurrentUser->data->user_login;
    else if(is_null($gCurrentUser) && !is_null(wp_get_current_user()->data->user_login))
      $usr = wp_get_current_user()->data->user_login;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>"<b>Database backup</b> has ended",'date'=>date('Y-m-d H:i:s'), 'plugin'=>"Better Search Replace Pro", 'user'=>$usr));
  }
}


add_action('transition_post_status', 'click5_transition_post_status',  10, 99);
function click5_transition_post_status( $new, $old, $post ) {
  $not_allowed_statuses = array( 
    'nav_menu_item',
    'attachment',
    'revision',
    'post',
    'page',
    'custom_css',
    'wp_block',
    'wp_template',
    'customize_changeset',
    'acf-field',
    'acf-field-group',
    'user_request',
    'oembed_cache',
    'wpcf7_contact_form',
    'acf-field-group'
  );

  if(!in_array( $post->post_type, $not_allowed_statuses, true )) {
    $type_post = ucfirst($post->post_type);
    global $wp_post_types;
    if($type_post == 'Faq') {
      $type_post = 'FAQ';
    }
    if($new == 'draft' && $old == 'draft') {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b>  has been saved as a draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new == 'publish' && $old == 'draft') {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new == 'publish' && $old == 'auto-draft') {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new == 'trash') {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $otp = "";
      if(str_contains(strtolower($wp_post_types[$post->post_type]->labels->singular_name), "forms" ) || str_contains(strtolower($wp_post_types[$post->post_type]->labels->singular_name), "form" ))
        $otp = "Contact Form";
      else
        $otp = $wp_post_types[$post->post_type]->labels->singular_name;
      $wpdb->insert($table_name, array('description'=>$otp . " <b>" . $post->post_title . "</b>  has been moved to trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new != 'trash' && $old == 'trash') {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b>  has been restored from trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new == 'pending' && $old == 'draft') { 
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b>  status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new == 'pending' && $old == 'publish') { 
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b>  status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new == 'draft' && $old == 'pending') { 
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b> status has been changed to draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    } elseif ($new != 'auto-draft' && $new != 'new' && $new != 'inherit' && $old != 'auto-draft' && $post->post_type != "wpforms") {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>$wp_post_types[$post->post_type]->labels->singular_name . " <b>" . $post->post_title . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post->post_type]->label, 'user'=>$gCurrentUser));     
    }
  }
  
  if($new == 'pending' && $old == 'draft') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($post->post_type == "post") { 
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post->post_title . "</b> status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "page") { 
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post->post_title . "</b> status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) { 
      if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
        $plugin = "Advanced Custom Fields Pro";
      else
        $plugin = "Advanced Custom Fields";
      $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
    }
   }

   if($new == 'pending' && $old == 'publish') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($post->post_type == "post") { 
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post->post_title . "</b> status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    }

    if($post->post_type == "page") { 
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post->post_title . "</b> status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) { 
      if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
        $plugin = "Advanced Custom Fields Pro";
      else
        $plugin = "Advanced Custom Fields";
      $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> status has been changed to pending",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
    }
   }
   if($new == 'publish' && $old == 'publish') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($post->post_type == "wpcf7_contact_form" && esc_attr(get_option('click5_history_log_contact-form-7/wp-contact-form-7.php')) == "1") { 
      $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $post->post_title . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Contact Form 7', 'user'=>$gCurrentUser));
    }   

    if($post->post_type == "wpforms" && ((esc_attr(get_option('click5_history_log_wpforms-lite/wpforms.php')) == "1" && is_plugin_active('wpforms-lite/wpforms.php')) || (esc_attr(get_option('click5_history_log_wpforms/wpforms.php')) == "1" && is_plugin_active('wpforms/wpforms.php')))) { 
      $pro = "";
      if(is_plugin_active('wpforms/wpforms.php') == "1")
        $pro = "Pro";
      if(!isset($_GET['action']))
      $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $post->post_title . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WPForms '.$pro, 'user'=>$gCurrentUser));
      
      /*add_action( 'wpforms_builder_save_form', function($form_id, $data){
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $data['settings']['form_title'] . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WPForms', 'user'=>$gCurrentUser));
      }, 10, 2 );*/
    
    
    } 

    if($post->post_type == "acf-field-group") { 
      global $gBlockDouble;
      $mod_time = new DateTime($post->post_modified);
      $create_time =  new DateTime($post->post_date);
      $diff_time = $mod_time->getTimestamp() - $create_time->getTimestamp();
      if($diff_time < 4) { 
        if((esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) {
          if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
            $plugin = "Advanced Custom Fields Pro";
          else
            $plugin = "Advanced Custom Fields";
          $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> has been added",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
        }
      } else {
        if(!$gBlockDouble) {
          if((esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) {
            if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
              $plugin = "Advanced Custom Fields Pro";
            else
              $plugin = "Advanced Custom Fields"; 
            $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
          }
          $gBlockDouble = true;
        } else {
          $gBlockDouble = false;
        }   
      } 
    }  
  }  

  /*if($new == 'inherit'){
    add_action('wpforms_save_form',function($_form_id, $form){
      global $wpdb;
      global $gCurrentUser;
      $table_name = $wpdb->prefix . "c5_history";
      if(esc_attr(get_option('click5_history_log_wpforms-lite/wpforms.php')) == "1") { 
        $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $form['post_title'] . "</b> has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WPForms', 'user'=>$gCurrentUser));
      } 
    },10,2);
  }*/

  if($new == 'publish' && $old == 'new') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($post->post_type == "wpcf7_contact_form" && esc_attr(get_option('click5_history_log_contact-form-7/wp-contact-form-7.php')) == "1") { 
      $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $post->post_title . "</b> has been added",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Contact Form 7', 'user'=>$gCurrentUser));
    } 

    if($post->post_type == "wpforms" && ((esc_attr(get_option('click5_history_log_wpforms-lite/wpforms.php')) == "1" && is_plugin_active('wpforms-lite/wpforms.php')) || (esc_attr(get_option('click5_history_log_wpforms/wpforms.php')) == "1" && is_plugin_active('wpforms/wpforms.php')))) { 
      $pro = "";
      if(is_plugin_active('wpforms/wpforms.php'))
        $pro = "Pro";
      if(isset($_GET['action']))
      {
        if($_GET['action'] == 'duplicate')
          $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $post->post_title . "</b> has been duplicated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WPForms '.$pro, 'user'=>$gCurrentUser));
      }else{
        $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $post->post_title . "</b> has been added",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WPForms '.$pro, 'user'=>$gCurrentUser));
      }
      
    } 

    if($post->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) { 
      if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
        $plugin = "Advanced Custom Fields Pro";

      else
        $plugin = "Advanced Custom Fields";
      $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> has been added",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
    } 
  }  

   if($new == 'draft' && $old == 'pending') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($post->post_type == "post") { 
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post->post_title . "</b> status has been changed to draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "page") { 
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post->post_title . "</b> status has been changed to draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) { 
      if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
        $plugin = "Advanced Custom Fields Pro";
      else
        $plugin = "Advanced Custom Fields";
      $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> status has been changed to draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
    }
   }

   if($new == 'draft' && $old == 'publish') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($post->post_type == "post") { 
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post->post_title . "</b> status has been changed to draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "page") { 
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post->post_title . "</b> status has been changed to draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) { 
      if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
        $plugin = "Advanced Custom Fields Pro";
      else
        $plugin = "Advanced Custom Fields";
      $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> status has been changed to draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
    }
   }

   if($new == 'publish' && $old == 'draft') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history"; 
    if($post->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) { 
      if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
        $plugin = "Advanced Custom Fields Pro";
      else
        $plugin = "Advanced Custom Fields";
      $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post->post_title . "</b> has been added",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
    } 
  }
   
  if($new == 'draft' && $old == 'draft') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $post_data = get_post($post->ID);
    if($post->post_type == "post") { 
      if($post->post_date == $post->post_modified) {
        $wpdb->insert($table_name, array('description'=>"Post <b>" . $post->post_title . "</b>  has been saved as a draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
      } else {
        $wpdb->insert($table_name, array('description'=>"Post <b>" . $post->post_title . "</b>  has been updated like a draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
      }
    }
    if($post->post_type == "page") { 
      if($post->post_date == $post->post_modified) {
        $wpdb->insert($table_name, array('description'=>"Page <b>" . $post->post_title . "</b>  has been saved as a draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
      } else {
        $wpdb->insert($table_name, array('description'=>"Page <b>" . $post->post_title . "</b>  has been updated like a draft",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
      }
    }
  } 
  if($new == 'future') {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $date_format = esc_attr(get_option('date_format'));
    $time_format = esc_attr(get_option('time_format'));
    $date_time_format = $date_format . " " . $time_format;
    if($post->post_type == "post") { 
      $wpdb->insert($table_name, array('description'=>"Post <b>" . $post->post_title . "</b> has beeen saved as a scheduled ",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
    }
    if($post->post_type == "page") { 
      $wpdb->insert($table_name, array('description'=>"Page <b>" . $post->post_title . "</b> has beeen saved as a scheduled ",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
    }
   }
}

add_action( 'untrash_post', 'click5_untrash_post' );
function click5_untrash_post($postid) {
  global $gCurrentUser;
  global $wpdb;
  $post_data = get_post($postid);
  $table_name = $wpdb->prefix . "c5_history";
  if($post_data->post_type == "post") {
    $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been restored from trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
  }
  if($post_data->post_type == "page") {
    $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been restored from trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
  }
  if($post_data->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) {
    if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
      $plugin = "Advanced Custom Fields Pro";
    else
      $plugin = "Advanced Custom Fields";
    $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post_data->post_title . "</b>  has been restored from trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
  }
}

add_action( 'wp_trash_post', 'click5_trash_post' );
function click5_trash_post($postid) {
  global $gCurrentUser;
  global $wpdb;
  $post_data = get_post($postid);
  $table_name = $wpdb->prefix . "c5_history";
  if($post_data->post_type == "post") {
    $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been moved to trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
  }
  if($post_data->post_type == "page") {
    $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been moved to trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
  }
  if($post_data->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) {
    if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
      $plugin = "Advanced Custom Fields Pro";
    else
      $plugin = "Advanced Custom Fields";
    $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post_data->post_title . "</b>  has been moved to trash",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
  }
}

add_action( 'delete_post', 'click5_delete_post' );
function click5_delete_post($postid) {
  global $gCurrentUser;
  global $wpdb;
  $post_data = get_post($postid);
  $file_type = explode("/", $post_data->post_mime_type)[1];
  if($file_type == "msword") {
    $file_type = "doc";
  }
  if($file_type == "vnd.ms-excel") {
    $file_type = "xls";
  }
  $table_name = $wpdb->prefix . "c5_history";
  if($post_data->post_type == 'attachment') {
    $wpdb->insert($table_name, array('description'=>"Media file" . " <b>" . $post_data->post_title . "." . $file_type . "</b>  has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Media', 'user'=>$gCurrentUser));
  }
  $not_allowed_statuses = array( 
    'nav_menu_item',
    'attachment',
    'revision',
    'post',
    'page',
    'custom_css',
    'wp_block',
    'wp_template',
    'customize_changeset',
    'acf-field',
    'acf-field-group',
    'user_request',
    'oembed_cache',
    'wpcf7_contact_form',
    'acf-field-group'
  );
  if(!in_array( $post_data->post_type, $not_allowed_statuses, true ) && $post_data->post_type != "wpforms") {
    global $wp_post_types;
    $type_post = ucfirst($post_data->post_type);
    if($type_post == 'Faq') {
      $type_post = 'FAQ';
    }
    $wpdb->insert($table_name, array('description'=>$wp_post_types[$post_data->post_type]->labels->singular_name . " <b>" . $post_data->post_title . "</b>  has been deleted pemanently",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$wp_post_types[$post_data->post_type]->label, 'user'=>$gCurrentUser));
  }
  if($post_data->post_type == "post") {
    $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been deleted pemanently",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>$gCurrentUser));
  }
  if($post_data->post_type == "page") {
    $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been deleted pemanently",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>$gCurrentUser));
  }
  if($post_data->post_type == "wpcf7_contact_form" && esc_attr(get_option('click5_history_log_contact-form-7/wp-contact-form-7.php')) == "1") {
    $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $post_data->post_title . "</b>  has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Contact Form 7', 'user'=>$gCurrentUser));
  }

  if($post_data->post_type == "wpforms" && ((esc_attr(get_option('click5_history_log_wpforms-lite/wpforms.php')) == "1" && is_plugin_active('wpforms-lite/wpforms.php')) || (esc_attr(get_option('click5_history_log_wpforms/wpforms.php')) == "1" && is_plugin_active('wpforms/wpforms.php')))) { 
    $pro = "";
    if(is_plugin_active('wpforms/wpforms.php'))
      $pro = "Pro";
    $wpdb->insert($table_name, array('description'=>"Contact Form <b>" . $post_data->post_title . "</b>  has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WPForms '.$pro, 'user'=>$gCurrentUser));
  }

  if($post_data->post_type == "acf-field-group" && (esc_attr(get_option('click5_history_log_advanced-custom-fields/acf.php')) == "1" || esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")) {
    if(esc_attr(get_option('click5_history_log_advanced-custom-fields-pro/acf.php')) == "1")
      $plugin = "Advanced Custom Fields Pro";
    else
      $plugin = "Advanced Custom Fields";
    $wpdb->insert($table_name, array('description'=>"Advanced Custom Field <b>" . $post_data->post_title . "</b> has been deleted pemanently",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin, 'user'=>$gCurrentUser));
  }
}

add_action( 'delete_user', 'click5_delete_user' );
function click5_delete_user( $user_id ) {
    $user_data = get_userdata( $user_id );
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>"User <b>" . $user_data->data->display_name . "</b>  has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Users', 'user'=>wp_get_current_user()->user_login));
}

add_action( 'set_user_role', function( $user_id, $role, $old_roles ) 
{
  global $wp_roles;
  $user_data = get_userdata( $user_id );
  global $wpdb;
  $role_displayName = array_values((array)$wp_roles->roles[$role]['name'])[0];
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"User <b>" . $user_data->data->display_name . "</b> role has been changed to <b>" .  ucfirst($role_displayName) . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Users', 'user'=>wp_get_current_user()->user_login));

}, 10, 3 );

function click5_update__profile_fields($user_id) {
  $user_data = get_userdata( $user_id );
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"User <b>" . $user_data->data->display_name . "</b>  has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Users', 'user'=>wp_get_current_user()->user_login));
}
add_action('edit_user_profile_update', 'click5_update__profile_fields');

add_action('create_category', 'click5_add_new_category', 10, 2);
function click5_add_new_category($category_id, $category_term_id){
  global $gCurrentUser;
  global $wpdb;
  $new_cat = get_category($category_id);
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"<b>" . $new_cat->name . "</b>  category has been created",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts / Categories', 'user'=>$gCurrentUser));
}

add_action('delete_category', 'click5_delete_category_fn',  10, 4 );
function click5_delete_category_fn($tt_id, $id, $data, $data2){
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"<b>" . $data->name . "</b>  category has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts / Categories', 'user'=>$gCurrentUser));
}

add_action ( 'edited_category', 'click5_edited_category_fn');
function click5_edited_category_fn( $category_id )
{
  global $gCurrentUser;
  global $wpdb;
  $new_cat = get_category($category_id);
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"<b>" . $new_cat->name . "</b>  category has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts / Categories', 'user'=>$gCurrentUser));
}

add_action('create_post_tag', 'click5_add_new_tag', 10, 2);

function click5_add_new_tag($tag_id, $tag_term_id){
  global $gCurrentUser;
  global $wpdb;
  $new_tag = get_tag($tag_id);
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"<b>" . $new_tag->name . "</b> tag has been created",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts / Tags', 'user'=>$gCurrentUser));
}

add_action('delete_post_tag', 'click5_delete_tag_fn',  10, 4 );
function click5_delete_tag_fn($tt_id, $id, $data, $data2){
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"<b>" . $data->name . "</b> tag has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts / Tags', 'user'=>$gCurrentUser));
}

add_action ( 'edit_post_tag', 'click5_edited_tag_fn');
function click5_edited_tag_fn( $tag_id )
{
  global $gCurrentUser;
  global $wpdb;
  $edit_tag = get_tag($tag_id);
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"<b>" . $edit_tag->name . "</b>  tag has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts / Tags', 'user'=>$gCurrentUser));
}

add_action('edit_term', 'click5_edit_term', 10, 3);
function click5_edit_term($term_id, $term_term_id, $term_data){
  if($term_data != "category" && $term_data != "post_tag") {
    global $gCurrentUser;
    global $wpdb;
    global $wp_post_types;
    $term_string = explode("-", $term_data);
    $new_term = get_term($term_id, $term_data);
    $table_name = $wpdb->prefix . "c5_history";
    if(property_exists($new_term, 'taxonomy')) {   
      $taxonomy_data = get_taxonomy($new_term->taxonomy);
      $plugin_name = 'Taxonomies / ' . $taxonomy_data->label;
    } else {
      $plugin_name = ucfirst($term_string[0]) . '/ Categories';
    }

    if($new_term->taxonomy != "nav_menu") { 
      if(property_exists($new_term, 'taxonomy')) {
        $wpdb->insert($table_name, array('description'=>"<b>" . $new_term->name . "</b> taxonomy has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin_name, 'user'=>$gCurrentUser));
      }
      else
      {
        $wpdb->insert($table_name, array('description'=>"<b>" . $new_term->name . "</b> category has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin_name, 'user'=>$gCurrentUser));
      }
    }
  }
}

add_action('create_term', 'click5_add_new_term', 10, 3);
function click5_add_new_term($term_id, $term_term_id, $term_data){
  if($term_data != "category" && $term_data != "post_tag") {
    global $gCurrentUser;
    global $wpdb;
    $term_string = explode("-", $term_data);
    $new_term = get_term($term_id, $term_data);
    if(property_exists($new_term, 'taxonomy')) {   
      $taxonomy_data = get_taxonomy($new_term->taxonomy);    
      $plugin_name = 'Taxonomies / ' . $taxonomy_data->label;
    } else {
      $plugin_name = ucfirst($term_string[0]) . '/ Categories';
    }
    $table_name = $wpdb->prefix . "c5_history";

    if($new_term->taxonomy != "nav_menu") {
      if(property_exists($new_term, 'taxonomy')) { 
        $wpdb->insert($table_name, array('description'=>"<b>" . $new_term->name . "</b> taxonomy has been created",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin_name, 'user'=>$gCurrentUser));
      }
      else
      {
        $wpdb->insert($table_name, array('description'=>"<b>" . $new_term->name . "</b> category has been created",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin_name, 'user'=>$gCurrentUser));
      }
    }
  }
}

add_action('delete_term', 'click5_delete_term', 10, 4);
function click5_delete_term($term_id, $term_term_id, $tr, $term_data){
  if($tr != "category" && $tr != "post_tag") {
    global $gCurrentUser;
    global $wpdb;
    global $wp_post_types;
    global $wp_post_types;
    $term_string = explode("-", $tr);
    $table_name = $wpdb->prefix . "c5_history";
    if(property_exists($term_data, 'taxonomy')) {    
      $taxonomy_data = get_taxonomy($term_data->taxonomy);
      $plugin_name = 'Taxonomies / ' . $taxonomy_data->label;
    } else {
      $plugin_name = ucfirst($term_string[0]) . ' / Categories';
    }
    if($term_data->taxonomy != "nav_menu") {
      if(property_exists($term_data, 'taxonomy')) {  
        $wpdb->insert($table_name, array('description'=>"<b>" . $term_data->name . "</b> taxonomy has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin_name, 'user'=>$gCurrentUser));
      } else {
        $wpdb->insert($table_name, array('description'=>"<b>" . $term_data->name . "</b> category has been deleted",'date'=>date('Y-m-d H:i:s'), 'plugin'=>$plugin_name, 'user'=>$gCurrentUser));
      }
    }
  }
}

add_filter("rest_request_before_callbacks","c5_history_log_rest_callback_get_old",10,3);

function c5_history_log_rest_callback_get_old($response, $handler, $request){
  if(esc_attr(get_option('click5_history_log_redirection/redirection.php')) == "1"){
    global $old_rest_callback;
    if($request->get_method() == "GET" && (strpos($request->get_route(),"/google-site-kit/") < 0 && strpos($request->get_route(),"/google-site-kit/") === false))
      return $response;

    if(strpos($request->get_route(),"/group/") > 0)
    {
      if(isset($request->get_params()['bulk']) && $request->get_params()['bulk'] == "delete"){
        $old_rest_callback = array();
        foreach($request->get_params()['items'] as $item){
          if(!class_exists("Red_Group")) return;
          $old_rest_callback[] = Red_Group::get($item)->to_json();
        }
      }else{
        if($request->get_params()['id'] != 0)
        if(!class_exists("Red_Group")) return;
          $old_rest_callback = Red_Group::get($request->get_params()['id'])->to_json();
      }
    }
  }

  global $googleSiteKit_data;
  if(strpos($request->get_route(),"/google-site-kit/") > -1 && strpos($request->get_route(),"/google-site-kit/") !== false){
      $googleSiteKit_data = $request->get_params();
  }
    return $response;
}

add_filter("rest_request_after_callbacks","c5_history_log_rest_callback",10,3);
function c5_history_log_rest_callback($response, $handler, $request){
  if(esc_attr(get_option('click5_history_log_redirection/redirection.php')) == "1")
  {
    if($request->get_method() == "GET" && (strpos($request->get_route(),"/google-site-kit/") < 0 && strpos($request->get_route(),"/google-site-kit/") === false))
    return $response;

  global $redirection_module_names;
  global $old_rest_callback;
  $redirection_module_names = array(
      "",
      "wordPress",
      "Apache",
      "Nginx"
  );

  $JSON_data = $request->get_params();
  global $wpdb;
  global $gCurrentUser;
  global $old_rest_callback;
  $usr = $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  if(is_null($gCurrentUser))
    $usr = "WordPress Core";

  if(strpos($request->get_route(),"/group/") > 0 || strpos($request->get_route(),"/group") > 0){
    if(isset($JSON_data['bulk'])){
      
      if($JSON_data['bulk'] == "delete"){
        foreach($old_rest_callback as $item){
          $wpdb->insert($table_name, array('description'=>'Group <b>'.$item['name'].'</b> has been deleted','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
        }
      }else if($JSON_data['bulk'] == "disable"){
        foreach($JSON_data['items'] as $item){
          if(!class_exists("Red_Group")) return;
          $item = Red_Group::get($item)->to_json();
          $wpdb->insert($table_name, array('description'=>'Group <b>'.$item['name'].'</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
        }
      }else if($JSON_data['bulk'] == "enable"){
        foreach($JSON_data['items'] as $item){
          if(!class_exists("Red_Group")) return;
          $item = Red_Group::get($item)->to_json();
          $wpdb->insert($table_name, array('description'=>'Group <b>'.$item['name'].'</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
        }
      }
  
    }else{
      if($JSON_data['id'] == 0){
        //$wpdb->insert($table_name, array('description'=>'Group <b>'.$JSON_data['name'].'</b> in module '.$redirection_module_names[$JSON_data['moduleId']].' has been created','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
        $wpdb->insert($table_name, array('description'=>'Group <b>'.$JSON_data['name'].'</b> has been created','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
      }else{
        $name_change = NULL;
        $module_change = NULL;
        if($old_rest_callback['name'] != $JSON_data['name'])
          $name_change = "Name: <b>".$old_rest_callback['name']."</b>";
    
        if($old_rest_callback['module_id'] != $JSON_data['moduleId'])
          $module_change = "Module: <b>".$redirection_module_names[$old_rest_callback['module_id']].'</b>';
        
          if(!is_null($name_change)  && !is_null($module_change))
            $name_change .= " and ";
        //$wpdb->insert($table_name, array('description'=>'Group <b>'.$old_rest_callback['name'].'</b> has been changed to '.$name_change.$module_change,'date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
        $wpdb->insert($table_name, array('description'=>'Group <b>'.$old_rest_callback['name'].'</b> has been edited','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
      }
    }
  }else if(strpos($request->get_route(),"/redirect/") > 0){
    if(isset($JSON_data['bulk'])){

      if($JSON_data['bulk'] == "disable"){
        foreach($JSON_data['items'] as $item){
          if(!class_exists("Red_Item")) return;
          $item = Red_Item::get_by_id($item)->to_json();
          $wpdb->insert($table_name, array('description'=>'Redirect '.$item['action_code'].' from <b>'.site_url($item['url']).'</b> to <b> '.$item['action_data']['url'].' </b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
        }
      }else if($JSON_data['bulk'] == "enable"){
        foreach($JSON_data['items'] as $item){
          if(!class_exists("Red_Item")) return;
          $item = Red_Item::get_by_id($item)->to_json();
          $wpdb->insert($table_name, array('description'=>'Redirect '.$item['action_code'].' from <b>'.site_url($item['url']).'</b> to <b> '.$item['action_data']['url'].' </b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
        }
      }
    }
  }
  }

  if(strpos($request->get_route(),"/google-site-kit/") > -1 && strpos($request->get_route(),"/google-site-kit/") !== false){
    if($response->status == 200){
      $google_data = $response->get_data();
      $google_request = $request->get_params();
      if(isset($request['data'])){

      }      global $googleSiteKit_data;
      //"/google-site-kit/v1/core/modules/data/activation"
      if($request->get_route() == "/google-site-kit/v1/core/modules/data/activation")
      {
        $google_slug_list = array(
          'analytics'         => "Analytics",
          'adsense'           => "AdSense",
          'searchconsole'     => "Search Console",
          'pagespeedinsights' => "PageSpeed Insights",
          'optimize'          => "Optimize",
          'tagmanager'        => "Tag Manager"

        );
        if(isset($google_request['JSON']))
        $google_request = $google_request['JSON'];
        else{
          if(is_array($google_request['data']))
            $google_request = $google_request['data'];
        }
        

        if(isset($google_request['slug']) && isset($google_request['active'])){
          if($google_request['active'] == true)
          {
            $google_slug = $google_request['slug'];
            $google_slug = str_replace("-","",$google_slug);
            $google_slug = str_replace("_","",$google_slug);
            $google_slug = strtolower($google_slug);
            if(isset($google_slug_list[$google_slug]))
              $google_slug = $google_slug_list[$google_slug];
            else
              $google_slug = ucwords($google_slug);

            $wpdb->insert($table_name, array('description'=>'<b>'.$google_slug.'</b> has been activated','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Site Kit by Google", 'user'=>$usr));
          }
        }
      }/*else if(str_contains($request->get_route(),"/data/settings")){
        if(isset($google_request['slug'])){
          if(!empty($_SESSION['google_module_slug']) && $google_request['slug'] == $_SESSION['google_module_slug'])
            return;
          if($google_request['slug'] != "search-console" && is_null($_SESSION['google_module_slug']))
            $_SESSION['google_module_slug'] = $google_request['slug'];
        }
      }else if($request->get_route() == "/google-site-kit/v1/core/site/data/connection"){
        if(isset($google_data['connected'])){
          if($google_data['connected']){
            $google_slug = $_SESSION['google_module_slug'];
            $google_slug = str_replace("-","",$google_slug);
            $google_slug = str_replace("_","",$google_slug);
            $google_slug = strtolower($google_slug);
            if(isset($google_slug_list[$google_slug]))
              $google_slug = $google_slug_list[$google_slug];
            else
              $google_slug = ucwords($google_slug);

            $wpdb->insert($table_name, array('description'=>'<b>'.$google_slug.'</b> has been connected','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Site Kit by Google", 'user'=>$usr));
            $_SESSION['google_module_slug'] = NULL;
          }
        }
      }*/
    }
  }

  return $response;
}



add_filter( 'redirection_create_redirect', 'click5_redirection_create_redirect', 10, 3 );
function click5_redirection_create_redirect($data)
{
  if(esc_attr(get_option('click5_history_log_redirection/redirection.php')) == "1"){
  global $wpdb;
  global $gCurrentUser;
  $usr = $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  if(is_null($gCurrentUser))
    $usr = "WordPress Core";


  $wpdb->insert($table_name, array('description'=>'Redirect '.$data['action_code'].' from <b>'.site_url($data['url']).'</b> to <b>'.$data['action_data'].'</b> has been created','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
}


  return $data;
}
add_filter( 'redirection_redirect_deleted', 'click5_redirection_redirect_deleted', 10, 3 );
function click5_redirection_redirect_deleted($data)
{
  if(esc_attr(get_option('click5_history_log_redirection/redirection.php')) == "1"){
  global $wpdb;
  global $gCurrentUser;
  $usr = $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  if(is_null($gCurrentUser))
    $usr = "WordPress Core";
  if(is_a($data,"Red_Item")){
    $data = $data->to_json();
    $wpdb->insert($table_name, array('description'=>'Redirect '.$data['action_code'].' from <b>'.site_url($data['url']).'</b> to <b>'.$data['action_data']['url'].'</b> has been deleted','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
  }
  } 
  return $data;
}
add_filter( 'redirection_redirect_updated', 'click5_redirection_redirect_updated', 10, 3 );
function click5_redirection_redirect_updated($data)
{
  if(esc_attr(get_option('click5_history_log_redirection/redirection.php')) == "1"){
  global $wpdb;
  global $gCurrentUser;
  $usr = $gCurrentUser;
  $table_name = $wpdb->prefix . "c5_history";
  if(is_null($gCurrentUser))
    $usr = "WordPress Core";

  if(is_a($data,"Red_Item")){
    $data =  $data->to_json();
    $wpdb->insert($table_name, array('description'=>'Redirect '.$data['action_code'].' from <b>'.site_url($data['url']).'</b> to <b>'.$data['action_data']['url'].'</b> has been edited','date'=>date('Y-m-d H:i:s'), 'plugin'=>"Redirection", 'user'=>$usr));
  }
}
  return $data;
}



add_action( 'update_option', function($option, $old_value, $value){
  if(strpos($option, 'home') !== false && $old_value != $value) {  
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>'Site address (URL) email address has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }

  if(strpos($option, 'wpe_cache_last_cleared') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>"<b>All caches</b> have been cleared",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WP Engine','user'=>$gCurrentUser));
    }

  if(strpos($option,'auto_update_themes') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $theme = "";
    
    if($old_value != $value)
    {
      if(count($value) > count($old_value))
      {
        $theme = wp_get_theme(array_values(array_diff($value,$old_value))[0]);
        $wpdb->insert($table_name, array('description'=>"<b>" . $theme->display("Name") . "</b> theme auto update has been enabled",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
      }
      else if(count($old_value) > count($value))
      {
        $theme = wp_get_theme(array_values(array_diff($old_value,$value))[0]);
        $wpdb->insert($table_name, array('description'=>"<b>" . $theme->display("Name") . "</b> theme auto update has been disabled",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Plugins', 'user'=>wp_get_current_user()->user_login));
      }
        
    }
  } 

  if(strpos($option, 'start_of_week') !== false && $old_value != $value) {  
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    
      if($value == 1)
      {
        $value = "Monday";
      }
      else if($value == 0)
      {
        $value = "Sunday";
      }
      else if($value == 2)
      {
        $value = "Tuesday";
      }
      else if($value == 3)
      {
        $value = "Wednesday";
      }
      else if($value == 4)
      {
        $value = "Thursday";
      }
      else if($value == 5)
      {
        $value = "Friday";
      }
      else if($value == 6)
      {
        $value = "Saturday";
      }
  
      $wpdb->insert($table_name, array('description'=>'<b>Week Starts On</b> field has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }
    if(strpos($option, 'date_format') !== false && $old_value != $value) {  
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value!="")
      {
        $wpdb->insert($table_name, array('description'=>'<b>Date format</b> has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
      }
    }
    if(strpos($option, 'time_format') !== false && $old_value != $value) {  
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value!="")
      {
        $wpdb->insert($table_name, array('description'=>'<b>Time format</b> has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
      }
    }
    if(strpos($option, 'WPLANG') !== false && $old_value != $value) {  
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      require_once ABSPATH . 'wp-admin/includes/translation-install.php';
      $translations = wp_get_available_translations();  
      $lang_name = "English";
      foreach($translations as $translation_item) {
        if($translation_item["language"] == $value) {
          $lang_name = $translation_item["english_name"];
          break;
        }
      }
      $wpdb->insert($table_name, array('description'=>'<b>Site language</b> has been changed to <b>' .  $lang_name . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
    }  
    if(strpos($option, 'timezone_string') !== false && $old_value != $value) {  
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value!="")
      {
        $wpdb->insert($table_name, array('description'=>'<b>Timezone</b> has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
      }
    }
    if(strpos($option, 'gmt_offset') !== false && $old_value != $value) {  
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value!="")
      {
        if($value>=0)
        {
          $value = "+". $value;
        }
        $wpdb->insert($table_name, array('description'=>'<b>Timezone</b> has been changed to <b>UTC' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
      }
    }

  if(strpos($option, 'siteurl') !== false && $old_value != $value) {  
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>'WordPress address (URL) email address has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }
  if(strpos($option, 'new_admin_email') !== false && $old_value != $value) {  
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>'Administration email address has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }
  if(strpos($option, 'blogdescription') !== false && $old_value != $value) {  
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>'Tagline has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }
  if(strpos($option, 'blogname') !== false && $old_value != $value) {  
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>'Site title has been changed to <b>' .  $value . '</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }
  if(strpos($option, 'classic-editor-replace') !== false) {  
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if($old_value == "classic" && $value == "block" && esc_attr(get_option('click5_history_log_classic-editor/classic-editor.php')) == "1") {
      $wpdb->insert($table_name, array('description'=>'Editor has been changed to <b>block</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Classic Editor', 'user'=>$gCurrentUser));
    }
    if($old_value == "block" && $value == "classic" && esc_attr(get_option('click5_history_log_classic-editor/classic-editor.php')) == "1") {
      $wpdb->insert($table_name, array('description'=>'Editor has been changed to <b>classic</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Classic Editor', 'user'=>$gCurrentUser));
    }
  }  

  //YOAST SEO
  if(strpos($option, 'wpseo_titles') !== false) {  
    if(isset($old_value["breadcrumbs-enable"]) && isset($value["breadcrumbs-enable"]))
    {
      if($old_value["breadcrumbs-enable"] != $value["breadcrumbs-enable"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["breadcrumbs-enable"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Breadcrumbs</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Breadcrumbs</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }
  }  
  else if(strpos($option, 'wpseo') !== false) {  
    if(isset($old_value["enable_xml_sitemap"]) && isset($value["enable_xml_sitemap"]))
    {
      if($old_value["enable_xml_sitemap"] != $value["enable_xml_sitemap"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_xml_sitemap"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>XML Sitemaps</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>XML Sitemaps</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }
    if(isset($old_value["keyword_analysis_active"]) && isset($value["keyword_analysis_active"]))
    {
      if($old_value["keyword_analysis_active"] != $value["keyword_analysis_active"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["keyword_analysis_active"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>SEO Analysis</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>SEO Analysis</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }
    if(isset($old_value["content_analysis_active"]) && isset($value["content_analysis_active"]))
    {
      if($old_value["content_analysis_active"] != $value["content_analysis_active"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["content_analysis_active"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Readability Analysis</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Readability Analysis</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }
    if(isset($old_value["enable_cornerstone_content"]) && isset($value["enable_cornerstone_content"]))
    {
      if($old_value["enable_cornerstone_content"] != $value["enable_cornerstone_content"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_cornerstone_content"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Cornerstone Content</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Cornerstone Content</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }
    if(isset($old_value["enable_text_link_counter"]) && isset($value["enable_text_link_counter"]))
    {
      if($old_value["enable_text_link_counter"] != $value["enable_text_link_counter"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_text_link_counter"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Text Link Counter</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Text Link Counter</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["enable_admin_bar_menu"]) && isset($value["enable_admin_bar_menu"]))
    {
      if($old_value["enable_admin_bar_menu"] != $value["enable_admin_bar_menu"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_admin_bar_menu"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Admin Bar Menu</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Admin Bar Menu</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["disableadvanced_meta"]) && isset($value["disableadvanced_meta"]))
    {
      if($old_value["disableadvanced_meta"] != $value["disableadvanced_meta"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["disableadvanced_meta"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Security: no advanced or schema settings for authors</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Security: no advanced or schema settings for authors</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["tracking"]) && isset($value["tracking"]))
    {
      if($old_value["tracking"] != $value["tracking"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["tracking"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Usage Tracking</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Usage Tracking</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["enable_headless_rest_endpoints"]) && isset($value["enable_headless_rest_endpoints"]))
    {
      if($old_value["enable_headless_rest_endpoints"] != $value["enable_headless_rest_endpoints"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_headless_rest_endpoints"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>REST API: Head Endpoint</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>REST API: Head Endpoint</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["enable_link_suggestions"]) && isset($value["enable_link_suggestions"]))
    {
      if($old_value["enable_link_suggestions"] != $value["enable_link_suggestions"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_link_suggestions"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Link suggestions</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Link suggestions</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["enable_metabox_insights"]) && isset($value["enable_metabox_insights"]))
    {
      if($old_value["enable_metabox_insights"] != $value["enable_metabox_insights"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_metabox_insights"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Insights</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Insights</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["enable_enhanced_slack_sharing"]) && isset($value["enable_enhanced_slack_sharing"]))
    {
      if($old_value["enable_enhanced_slack_sharing"] != $value["enable_enhanced_slack_sharing"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["enable_enhanced_slack_sharing"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Enhanced Slack Sharing</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Enhanced Slack Sharing</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["semrush_integration_active"]) && isset($value["semrush_integration_active"]))
    {
      if($old_value["semrush_integration_active"] != $value["semrush_integration_active"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["semrush_integration_active"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Semrush Integration</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Semrush Integration</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["ryte_indexability"]) && isset($value["ryte_indexability"]))
    {
      if($old_value["ryte_indexability"] != $value["ryte_indexability"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["ryte_indexability"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Ryte Integration</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Ryte Integration</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    
    if(isset($old_value["algolia_integration_active"]) && isset($value["algolia_integration_active"]))
    {
      if($old_value["algolia_integration_active"] != $value["algolia_integration_active"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["algolia_integration_active"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Algolia Integration</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Algolia Integration</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["zapier_integration_active"]) && isset($value["zapier_integration_active"]))
    {
      if($old_value["zapier_integration_active"] != $value["zapier_integration_active"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["zapier_integration_active"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Zapier Integration</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Zapier Integration</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["wincher_integration_active"]) && isset($value["wincher_integration_active"]))
    {
      if($old_value["wincher_integration_active"] != $value["wincher_integration_active"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value["wincher_integration_active"]) {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Wincher Integration</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
          }     
        } else {
          if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
            $wpdb->insert($table_name, array('description'=>'<b>Wincher Integration</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser));
          }
        }
      }
    }

    if(isset($old_value["baiduverify"]) && isset($value["baiduverify"]))
    {
      if($old_value["baiduverify"] != $value["baiduverify"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
          $wpdb->insert($table_name, array('description'=>'<b>Baidu Verification Code</b> has been set to <b>'.$value["baiduverify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
        } 
      }
    }

    if(isset($old_value["msverify"]) && isset($value["msverify"]))
    {
      if($old_value["msverify"] != $value["msverify"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
          $wpdb->insert($table_name, array('description'=>'<b>Bing Verification Code</b> has been set to <b>'.$value["msverify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
        } 
      }
    }

    if(isset($old_value["googleverify"]) && isset($value["googleverify"]))
    {
      if($old_value["googleverify"] != $value["googleverify"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
          $wpdb->insert($table_name, array('description'=>'<b>Google Verification Code</b> has been set to <b>'.$value["googleverify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
        } 
      }
    }

    if(isset($old_value["yandexverify"]) && isset($value["yandexverify"]))
    {
      if($old_value["yandexverify"] != $value["yandexverify"]) {
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if(((esc_attr(get_option('click5_history_log_wordpress-seo/wp-seo.php')) == "1" && is_plugin_active('wordpress-seo/wp-seo.php')) || (esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1" && is_plugin_active('wordpress-seo-premium/wp-seo-premium.php')))) { 
          $wpdb->insert($table_name, array('description'=>'<b>Yandex Verification Code</b> has been set to <b>'.$value["yandexverify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO', 'user'=>$gCurrentUser)); 
        } 
      }
    }
    if(strpos($option, "wpseo_premium") !== false)
    {
      if(esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1") { 
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        $save_value = $value;
        $save_old_value = $old_value;
        if(is_array($old_value["workouts"]) && is_array($value["workouts"])){
          $old_value = $old_value["workouts"];
          $value = $value["workouts"];
          if(is_array($old_value["cornerstone"]) && is_array($value["cornerstone"])){
            $workouts = array(
              "chooseCornerstones" => "Choose your cornerstones",
              "markCornerstones" => "Mark these articles as cornerstone content",
              "checkCornerstones" => "Check whether your cornerstones are correct",
              "checkLinks" => "Check the number of incoming internal links of your cornerstones",
              "addLinks" => "Add internal links towards your cornerstones",
            );
            $old_value = $old_value["cornerstone"];
            $value = $value["cornerstone"];
            if(is_array($old_value["finishedSteps"]) && is_array($value["finishedSteps"])){
              $old_value = $old_value["finishedSteps"];
              $value = $value["finishedSteps"];
              if(count($old_value) != count($value))
              {
                if(empty($old_value) && !empty($value)){
                  $val = array_diff($value,$old_value);
                  if(count($val) > 1)
                    $wpdb->insert($table_name, array('description'=>'<b>All</b> workouts has been finished','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  else
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[$value[0]].'</b> has been finished','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                }else if(empty($value) && !empty($old_value)){
                  $val = array_diff($old_value,$value);
                  if(count($val) > 1)
                    $wpdb->insert($table_name, array('description'=>'<b>All</b> workouts has been revised','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  else
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[$old_value[0]].'</b> has been revised','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                }else{
                  if(count($value) > count($old_value)){
                    $val = array_diff($value,$old_value);
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[array_values($val)[0]].'</b> has been finished','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  }else if(count($value) < count($old_value)){
                    $val = array_diff($old_value,$value);
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[array_values($val)[0]].'</b> has been revised','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  }
                }
              }
            }
            $old_value = $save_old_value;
            $value = $save_value;
            $old_value = $old_value["workouts"];
            $value = $value["workouts"];
          }
  
          if(is_array($old_value["orphaned"]) && is_array($value["orphaned"])){
            $old_value = $old_value["orphaned"];
            $value = $value["orphaned"];
            if(is_array($old_value["finishedSteps"]) && is_array($value["finishedSteps"])){
              $workouts = array(
                "improveRemove" => "Love it or leave it",
                "update" => "Should you update your article?",
                "addLinks" => "Add internal links towards your orphaned articles.",
              );
              $old_value = $old_value["finishedSteps"];
              $value = $value["finishedSteps"];
              if(count($old_value) != count($value))
              {
                if(empty($old_value) && !empty($value)){
                  $val = array_diff($value,$old_value);
                  if(count($val) > 1)
                    $wpdb->insert($table_name, array('description'=>'<b>All</b> workouts has been finished','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  else
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[$value[0]].'</b> has been finished','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                }else if(empty($value) && !empty($old_value)){
                  $val = array_diff($old_value,$value);
                  if(count($val) > 1)
                    $wpdb->insert($table_name, array('description'=>'<b>All</b> workouts has been revised','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  else
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[$old_value[0]].'</b> has been revised','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                }else{
                  if(count($value) > count($old_value)){
                    $val = array_diff($value,$old_value);
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[array_values($val)[0]].'</b> has been finished','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  }else if(count($value) < count($old_value)){
                    $val = array_diff($old_value,$value);
                    $wpdb->insert($table_name, array('description'=>'Workout <b>'.$workouts[array_values($val)[0]].'</b> has been revised','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$gCurrentUser)); 
                  }
                }
              }
            }
            $old_value = $save_old_value;
            $value = $save_value;
          }
        }
      }
    }
    if(strpos($option, "wpseo-premium-redirects-base") !== false){
      if(esc_attr(get_option('click5_history_log_wordpress-seo-premium/wp-seo-premium.php')) == "1"){
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        $usr = get_currentuserinfo()->data->user_login;
        if(!is_null($gCurrentUser))
          $usr = $gCurrentUser;
        $redirect_add = array_diff(array_keys($value),array_keys($old_value));
        $redirect_remove = array_diff(array_keys($old_value),array_keys($value));
        if(!empty($redirect_add) && empty($redirect_remove)){
          $redirect_info = $value[array_values($redirect_add)[0]];
          $wpdb->insert($table_name, array('description'=>'Redirect '.$redirect_info['type'].' from <b>'.esc_url(home_url($redirect_info['origin'])).'</b> to <b>'.esc_url(home_url($redirect_info['url'])).'</b> has been created','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$usr)); 
        }else if(empty($redirect_add) && !empty($redirect_remove)){
          if(count($redirect_remove) > 1){
            foreach(array_values($redirect_remove) as $index){
              $redirect_info = $old_value[$index];
              $wpdb->insert($table_name, array('description'=>'Redirect '.$redirect_info['type'].' from <b>'.esc_url(home_url($redirect_info['origin'])).'</b> to <b>'.esc_url(home_url($redirect_info['url'])).'</b> has been deleted','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$usr)); 
            }
          }else {
            $redirect_info = $old_value[array_values($redirect_remove)[0]];
            $wpdb->insert($table_name, array('description'=>'Redirect '.$redirect_info['type'].' from <b>'.esc_url(home_url($redirect_info['origin'])).'</b> to <b>'.esc_url(home_url($redirect_info['url'])).'</b> has been deleted','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Yoast SEO Premium', 'user'=>$usr)); 
          }
        }
      }
    }
  }

  //RankMath SEO
  if(esc_attr(get_option('click5_history_log_seo-by-rank-math/rank-math.php')) == "1") {
  if(strpos($option, 'rank_math_modules') !== false) { 
      $module_status = "";
      $module_name = "";
      if(count($old_value) > count($value) )
      {
        $module_status = "turned off";
      }
      else if(count($old_value) < count($value))
      {
        $module_status = "turned on";
      }

      if($module_status == "turned on")
      {
        foreach($value as $item)
        {
          if(in_array($item, $old_value) == false)
          {
            $module_name = $item;
            break;
          }
        }
      }
      else if ($module_status == "turned off")
      {
        foreach($old_value as $item)
        {
          if(in_array($item, $value) == false)
          {
            $module_name = $item;
            break;
          }
        }
      }

      if($module_status != "" && $module_name != "")
      {
        if (function_exists('str_replace'))
      {
        $module_name = str_replace('_', ' ', $module_name);
        $module_name = str_replace('-', ' ', $module_name);
      }
        $premium_modules = array(
          '404 monitor',
          'analytics',
          'bbpress',
          'image seo',
          'local seo',
          'news sitemap',
          "redirections",
          'rich snippet',
          'video sitemap',
          'woocommerce'
        );

        if(in_array(strtolower($module_name),$premium_modules) == true)
        {
          if(esc_attr(get_option('click5_history_log_seo-by-rank-math-pro/rank-math-pro.php')) != "1")
            return;

          $premium = 'Pro';
        }
          
        else
          $premium = '';
        

        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>'Module <b>'.$module_name. '</b> has been ' .$module_status ,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math '.$premium, 'user'=>$gCurrentUser)); 
      }
      
  }
  
  if(strpos($option, 'rank-math-options-sitemap') !== false) {  
    if($old_value["items_per_page"] != $value["items_per_page"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>'<b>Items per page</b> has been changed from '.$old_value["items_per_page"]. ' to <b> '.$value["items_per_page"].'</b> in XML Sitemap'  ,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["include_images"] != $value["include_images"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value["include_images"]=="on") {
        $wpdb->insert($table_name, array('description'=>'<b>Images in Sitemaps</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
           
    } else {
        $wpdb->insert($table_name, array('description'=>'<b>Images in Sitemaps</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
    }
    }
    if($old_value["include_featured_image"] != $value["include_featured_image"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value["include_featured_image"]=="on") {
        $wpdb->insert($table_name, array('description'=>'<b>Featured Images in Sitemaps</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
           
    } else {
        $wpdb->insert($table_name, array('description'=>'<b>Featured Images in Sitemaps</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
    }
    }

    if($old_value["ping_search_engines"] != $value["ping_search_engines"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value["ping_search_engines"]=="on") {
        $wpdb->insert($table_name, array('description'=>'<b>Ping Search Engines</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
           
    } else {
        $wpdb->insert($table_name, array('description'=>'<b>Ping Search Engines</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
    }
    }

    if($old_value["exclude_posts"] != $value["exclude_posts"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      $changedTo = "empty";
      $changedFrom ="empty";
      if(isset($value["exclude_posts"])&& $value["exclude_posts"] != "")
      {
        $changedTo = $value["exclude_posts"];
      }
      if(isset($old_value["exclude_posts"])&& $old_value["exclude_posts"] != "")
      {
        $changedFrom = $old_value["exclude_posts"];
      }
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>'<b>Exclude Posts Field</b> has been changed from '. $changedFrom. ' to <b>'.$changedTo.'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["exclude_terms"] != $value["exclude_terms"]) {
      global $gCurrentUser;
      global $wpdb;
      $changedTo = "empty";
      $changedFrom ="empty";
      if(isset($value["exclude_terms"])&& $value["exclude_terms"] != "")
      {
        $changedTo = $value["exclude_terms"];
      }
      if(isset($old_value["exclude_terms"])&& $old_value["exclude_terms"] != "")
      {
        $changedFrom = $old_value["exclude_terms"];
      }
      $table_name = $wpdb->prefix . "c5_history";
      $wpdb->insert($table_name, array('description'=>'<b>Exclude Terms Field</b> has been changed from '. $changedFrom. ' to <b>'.$changedTo.'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["pt_post_sitemap"] != $value["pt_post_sitemap"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        if($value["pt_post_sitemap"]=="on") {
          $wpdb->insert($table_name, array('description'=>'<b>Posts</b> has been included to sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
            
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Posts</b> has been excluded from sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
      }
    }
    if($old_value["pt_page_sitemap"] != $value["pt_page_sitemap"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        if($value["pt_page_sitemap"]=="on") {
          $wpdb->insert($table_name, array('description'=>'<b>Pages</b> has been included to sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
            
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Pages</b> has been excluded from sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
      }
    }

    if($old_value["pt_attachment_sitemap"] != $value["pt_attachment_sitemap"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        if($value["pt_attachment_sitemap"]=="on") {
          $wpdb->insert($table_name, array('description'=>'<b>Attachments</b> has been included to sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
            
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Attachments</b> has been excluded from sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
      }
    }

    if($old_value["tax_category_sitemap"] != $value["tax_category_sitemap"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        if($value["tax_category_sitemap"]=="on") {
          $wpdb->insert($table_name, array('description'=>'<b>Categories</b> has been included to sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
            
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Categories</b> has been excluded from sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
      }
    }

    if($old_value["tax_post_tag_sitemap"] != $value["tax_post_tag_sitemap"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        if($value["tax_post_tag_sitemap"]=="on") {
          $wpdb->insert($table_name, array('description'=>'<b>Tags</b> has been included to sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
            
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Tags</b> has been excluded from sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
      }
    }
  }
  if(strpos($option, 'rank-math-options-general') !== false) {  

    if($old_value["breadcrumbs"] != $value["breadcrumbs"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
      if($value["breadcrumbs"]) {
          $wpdb->insert($table_name, array('description'=>'<b>Breadcrumbs</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
             
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Breadcrumbs</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser));
      }
    }
   
    
    if($old_value["google_verify"] != $value["google_verify"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>'<b>Google Verification Code</b> has been set to <b>'.$value["google_verify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["bing_verify"] != $value["bing_verify"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>'<b>Bing Verification Code</b> has been set to <b>'.$value["bing_verify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["baidu_verify"] != $value["baidu_verify"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>'<b>Baidu Verification Code</b> has been set to <b>'.$value["baidu_verify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["yandex_verify"] != $value["yandex_verify"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>'<b>Yandex Verification Code</b> has been set to <b>'.$value["yandex_verify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["pinterest_verify"] != $value["pinterest_verify"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>'<b>Pinterest Verification Code</b> has been set to <b>'.$value["pinterest_verify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }

    if($old_value["norton_verify"] != $value["norton_verify"]) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history";
        $wpdb->insert($table_name, array('description'=>'<b>Norton Safe Web Verification Code</b> has been set to <b>'.$value["norton_verify"] .'</b>','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Rank Math', 'user'=>$gCurrentUser)); 
    }
    
  }
}


//All In One SEO
if(esc_attr(get_option('click5_history_log_all-in-one-seo-pack/all_in_one_seo_pack.php')) == "1" || esc_attr(get_option('click5_history_log_all-in-one-seo-pack-pro/all_in_one_seo_pack.php')) == "1") {
  if((strpos($option, 'aioseo_options') !== false && is_plugin_active('all-in-one-seo-pack/all_in_one_seo_pack.php')) || (strpos($option, 'aioseo_options_internal_pro') !== false && is_plugin_active('all-in-one-seo-pack-pro/all_in_one_seo_pack.php'))) { 
    if(!function_exists('aioseo')) 
      return;
    global $click5_aioseo_options_old;
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $click5_aioseo_options_new = aioseo()->core->optionsCache->getOptions( "aioseo_options" );
    $breadcrumbs_old = $click5_aioseo_options_old["breadcrumbs"]["enable"]["value"];
    $breadcrumbs_new = $click5_aioseo_options_new["breadcrumbs"]["enable"]["value"];
    $sitemap_old = $click5_aioseo_options_old["sitemap"]["general"]["enable"]["value"];
    $sitemap_new = $click5_aioseo_options_new["sitemap"]["general"]["enable"]["value"];
    $sitemap_indexes_old = $click5_aioseo_options_old["sitemap"]["general"]["indexes"]["value"];
    $sitemap_indexes_new = $click5_aioseo_options_new["sitemap"]["general"]["indexes"]["value"];
    $sitemap_html_old = $click5_aioseo_options_old["sitemap"]["html"]["enable"]["value"];
    $sitemap_html_new = $click5_aioseo_options_new["sitemap"]["html"]["enable"]["value"];
    $sitemap_links_old = $click5_aioseo_options_old["sitemap"]["general"]["linksPerIndex"]["value"];
    $sitemap_links_new = $click5_aioseo_options_new["sitemap"]["general"]["linksPerIndex"]["value"];
    $sitemap_author_old = $click5_aioseo_options_old["sitemap"]["general"]["author"]["value"];
    $sitemap_author_new = $click5_aioseo_options_new["sitemap"]["general"]["author"]["value"];
    $sitemap_date_old = $click5_aioseo_options_old["sitemap"]["general"]["date"]["value"];
    $sitemap_date_new = $click5_aioseo_options_new["sitemap"]["general"]["date"]["value"];
    $sitemap_postTypes_old = $click5_aioseo_options_old["sitemap"]["general"]["postTypes"]["all"]["value"];
    $sitemap_postTypes_new = $click5_aioseo_options_new["sitemap"]["general"]["postTypes"]["all"]["value"];
    $sitemap_taxonomies_old = $click5_aioseo_options_old["sitemap"]["general"]["taxonomies"]["all"]["value"];
    $sitemap_taxonomies_new = $click5_aioseo_options_new["sitemap"]["general"]["taxonomies"]["all"]["value"];
    $sitemap_additionalPages_old = $click5_aioseo_options_old["sitemap"]["general"]["additionalPages"]["enable"]["value"];
    $sitemap_additionalPages_new = $click5_aioseo_options_new["sitemap"]["general"]["additionalPages"]["enable"]["value"];
    $sitemap_advancedSettings_old = $click5_aioseo_options_old["sitemap"]["general"]["advancedSettings"]["enable"]["value"];
    $sitemap_advancedSettings_new = $click5_aioseo_options_new["sitemap"]["general"]["additionalPages"]["enable"]["value"];

    $sitemap_html_postTypes_old = $click5_aioseo_options_old["sitemap"]["html"]["postTypes"]["all"]["value"];
    $sitemap_html_postTypes_new = $click5_aioseo_options_new["sitemap"]["html"]["postTypes"]["all"]["value"];
    $sitemap_html_taxonomies_old = $click5_aioseo_options_old["sitemap"]["html"]["taxonomies"]["all"]["value"];
    $sitemap_html_taxonomies_new = $click5_aioseo_options_new["sitemap"]["html"]["taxonomies"]["all"]["value"];
    $sitemap_html_sortOrder_old = $click5_aioseo_options_old["sitemap"]["html"]["sortOrder"]["value"];
    $sitemap_html_sortOrder_new = $click5_aioseo_options_new["sitemap"]["html"]["sortOrder"]["value"];
    $sitemap_html_sortDirection_old = $click5_aioseo_options_old["sitemap"]["html"]["sortDirection"]["value"];
    $sitemap_html_sortDirection_new = $click5_aioseo_options_new["sitemap"]["html"]["sortDirection"]["value"];
    $sitemap_html_publicationDate_old = $click5_aioseo_options_old["sitemap"]["html"]["publicationDate"]["value"];
    $sitemap_html_publicationDate_new = $click5_aioseo_options_new["sitemap"]["html"]["publicationDate"]["value"];
    $sitemap_html_compactArchives_old = $click5_aioseo_options_old["sitemap"]["html"]["compactArchives"]["value"];
    $sitemap_html_compactArchives_new = $click5_aioseo_options_new["sitemap"]["html"]["compactArchives"]["value"];
    $sitemap_html_advancedSettings_old = $click5_aioseo_options_old["sitemap"]["html"]["advancedSettings"]["enable"]["value"];
    $sitemap_html_advancedSettings_new = $click5_aioseo_options_new["sitemap"]["html"]["advancedSettings"]["enable"]["value"];
    $access_controll_old = $click5_aioseo_options_old['accessControl'];
    $access_controll_new = $click5_aioseo_options_new['accessControl'];
    $advanced_old = $click5_aioseo_options_old['advanced'];
    $advanced_new = $click5_aioseo_options_new['advanced'];


    if((esc_attr(get_option('click5_history_log_all-in-one-seo-pack-pro/all_in_one_seo_pack.php')) == "1") && is_plugin_active('all-in-one-seo-pack-pro/all_in_one_seo_pack.php')){
      $aio_plugin_name = "All In One SEO Pro";
    }else{
      $aio_plugin_name = "All In One SEO";
    }
    //* ACCESS CONTROLL */
    $is_changed = false;
    foreach($access_controll_new as $control => $val){
      global $wp_roles;
      foreach($wp_roles->role_names as $_role => $roleData){
        $roleOutput = $roleData;
        $roleToCheck = strtolower(str_replace(" ","",$roleOutput));
        if(strtolower($control) == $roleToCheck){
          $roleOutput = $roleData;
          break;
        }

        $roleOutput = $control;
      }
      if(is_array($val)){
        $control_added = "";
        $control_removed = "";
        $is_changed = false;
        $tmp_control = $access_controll_old;
        $tmp_control = $tmp_control[$control];
        if($val['useDefault']['value'] != $tmp_control['useDefault']['value'])
        {
          if($val['useDefault']['value']){
            $wpdb->insert($table_name, array('description'=>"<b>".$roleOutput.'</b> Default Settings has been turned on in Access Control tab','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
          }else{
            $wpdb->insert($table_name, array('description'=>"<b>".$roleOutput.'</b> Default Settings has been turned off in Access Control tab','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
          }
        }
            /*foreach($val as $key => $index){
              if($index['value'] != $tmp_control[$key]['value'])
              {
                $is_changed = true;
                if($index['value']){
                  $control_added .= "<b>".$key."</b>, ";
                }else{
                  if($key == "useDefault")
                    $key = "Use Default Settings";
                  $control_removed .= "<b>".$key."</b>, ";
                }
              }
              
            }
          if($is_changed && $val['useDefault']['value'] == false)
          {
            if(!empty($control_added))
              $control_added = "<br>Added ".$control_added;
            if(!empty($control_removed))
              $control_removed = "<br>Removed ".$control_removed;
            $wpdb->insert($table_name, array('description'=>'Access Control settings for <b>'.$control.'</b> has been changed'.$control_added.$control_removed,'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
          }*/
            
      }
    }

    /* ADVANCED */

    $advanced_names = array(
      "truSeo" => "TruSEO Score & Content",
      "headlineAnalyzer"  => "Headline Analyzer",
      "dashboardWidgets"  => "Dashboard Widgets",
      "announcements"     => "Announcements",
      "adminBarMenu"      => "Admin Bar Menu",
      "autoUpdates"       => "Automatic Updates",

    );

    foreach($advanced_new as $name => $array){
      if(isset($array['value']))
      {
        $tmp_advanced = $advanced_old;
        if($array['value'] != $tmp_advanced[$name]['value']){
          if(is_string($array['value'])){

            $name = $advanced_names[$name];
            $wpdb->insert($table_name, array('description'=>'Setting <b>'.$name.'</b> has been set to '.$array['value'],'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
          }else{
            if($array['value'] == true){
              if($name == "adminBarMenu" || $name == "dashboardWidgets" || $name == "announcements")
                $action = "set to Show";
              else
                $action = "enabled";

              $name = $advanced_names[$name];
              $wpdb->insert($table_name, array('description'=>'Setting <b>'.$name.'</b> has been '.$action,'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
            }else if($array['value'] == false){
              if($name == "adminBarMenu" || $name == "dashboardWidgets" || $name == "announcements")
                $action = "set to Hide";
              else
                $action = "disabled";
                
              $name = $advanced_names[$name];
              $wpdb->insert($table_name, array('description'=>'Setting <b>'.$name.'</b> has been '.$action,'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
            }
          }
        }
      }else{
        if(is_array($array['all']) && !empty($array['all'])){
          $tmp_advanced = $advanced_old[$name];
          if($name == "postTypes")
            $name = "Post Types";
          else if($name == "taxonomies")
            $name = "Taxonomy";
          if($array['all']['value']){

            if($array['all']['value'] != $tmp_advanced['all']['value'])
                $wpdb->insert($table_name, array('description'=>'<b>Include All '.$name.'</b> has been enabled in Advanced tab','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
              
          }else{
            if($array['all']['value'] != $tmp_advanced['all']['value'])
              $wpdb->insert($table_name, array('description'=>'<b>Include All '.$name.'</b> has been disabled in Advanced tab','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
            
            /*
            if($array['included']['value'] != $tmp_advanced['included']['value']){
              $tmp_added = array_diff($array['included']['value'],$tmp_advanced['included']['value']);
              $tmp_removed = array_diff($tmp_advanced['included']['value'],$array['included']['value']);
              $output_added = "";
              $output_removed = "";
              foreach($tmp_added as $added){
                $output_added .= "<b>".$added."</b>, ";
              }

              foreach($tmp_removed as $removed){
                $output_removed .= "<b>".$removed."</b>, ";
              }

              if(!empty($output_added))
                $output_added = "<br>Added: ".$output_added;
              if(!empty($output_removed))
                $output_removed = "<br>Removed: ".$output_removed;
              //$wpdb->insert($table_name, array('description'=>'Setting <b>'.$name.'</b> has been changed '.$output_added.$output_removed,'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
            }
          */}
        }
      }
    }


    if($sitemap_html_advancedSettings_old!= $sitemap_html_advancedSettings_new)
    {
      if($sitemap_html_advancedSettings_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Advanced Settings</b> has been turned on in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Advanced Settings</b> has been turned off in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_html_compactArchives_old!= $sitemap_html_compactArchives_new)
    {
      if($sitemap_html_compactArchives_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Compact Archives</b> has been enabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Compact Archives</b> has been disabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_html_publicationDate_old!= $sitemap_html_publicationDate_new)
    {
      if($sitemap_html_publicationDate_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Publication Date</b> has been enabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Publication Date</b> has been disabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_html_sortDirection_old!= $sitemap_html_sortDirection_new)
    {
      $sitemap_html_direction_text_new = $sitemap_html_sortDirection_new;
      $sitemap_html_direction_text_old = $sitemap_html_sortDirection_old;
      if (function_exists('str_replace'))
      {
        $sitemap_html_direction_text_new = str_replace('_', ' ', $sitemap_html_sortDirection_new);
        $sitemap_html_direction_text_old = str_replace('_', ' ', $sitemap_html_sortDirection_old);
      }
      $wpdb->insert($table_name, array('description'=>'<b>Sort Order</b> has been changed from '.$sitemap_html_direction_text_old. ' to <b> '.$sitemap_html_direction_text_new.'</b> in HTML Sitemap'  ,'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
    }


    if($sitemap_html_sortOrder_old!= $sitemap_html_sortOrder_new)
    {
      $sitemap_html_order_text_new = $sitemap_html_sortOrder_new;
      $sitemap_html_order_text_old = $sitemap_html_sortOrder_old;
      if (function_exists('str_replace'))
      {
        $sitemap_html_order_text_new = str_replace('_', ' ', $sitemap_html_sortOrder_new);
        $sitemap_html_order_text_old = str_replace('_', ' ', $sitemap_html_sortOrder_old);
      }
      $wpdb->insert($table_name, array('description'=>'<b>Sort Order</b> has been changed from '.$sitemap_html_order_text_old. ' to <b> '.$sitemap_html_order_text_new.'</b> in HTML Sitemap'  ,'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
    }

    if($sitemap_html_taxonomies_old != $sitemap_html_taxonomies_new)
    {
      if($sitemap_html_taxonomies_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Taxonomies</b> has been enabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Taxonomies</b> has been disabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_html_postTypes_old!= $sitemap_html_postTypes_new)
    {
      if($sitemap_html_postTypes_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Post Types</b> has been enabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Post Types</b> has been disabled in HTML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_advancedSettings_old!= $sitemap_advancedSettings_new)
    {
      if($sitemap_advancedSettings_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Advanced Settings</b> has been turned on in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Advanced Settings</b> has been turned off in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_additionalPages_old!= $sitemap_additionalPages_new)
    {
      if($sitemap_additionalPages_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Additional Pages</b> has been turned on in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Additional Pages</b> has been turned off in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_taxonomies_old != $sitemap_taxonomies_new)
    {
      if($sitemap_taxonomies_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Taxonomies</b> has been enabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Taxonomies</b> has been disabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_postTypes_old!= $sitemap_postTypes_new)
    {
      if($sitemap_postTypes_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Post Types</b> has been enabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Include All Post Types</b> has been disabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }


    if($sitemap_date_old!= $sitemap_date_new)
    {
      if($sitemap_date_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Date Archive Sitemap</b> has been enabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Date Archive Sitemap</b> has been disabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_author_old!= $sitemap_author_new)
    {
      if($sitemap_author_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Author Sitemap</b> has been enabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Author Sitemap</b> has been disabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }

    if($sitemap_links_old!= $sitemap_links_new)
    {
      $wpdb->insert($table_name, array('description'=>'<b>Links Per Sitemap</b> has been changed from '.$sitemap_links_old. ' to <b> '.$sitemap_links_new.'</b> in XML Sitemap'  ,'date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
    }

    if($breadcrumbs_old!= $breadcrumbs_new)
    {
      if($breadcrumbs_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Breadcrumbs</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Breadcrumbs</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }
    if($sitemap_old!= $sitemap_new)
    {
      if($sitemap_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Sitemap XML</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Sitemap XML</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }
    if($sitemap_indexes_old!= $sitemap_indexes_new)
    {
      if($sitemap_indexes_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Sitemap Indexes</b> has been enabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Sitemap Indexes</b> has been disabled in XML Sitemap','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }
    if($sitemap_html_old!= $sitemap_html_new)
    {
      if($sitemap_html_new) {
          $wpdb->insert($table_name, array('description'=>'<b>Sitemap HTML</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser)); 
      } else {
          $wpdb->insert($table_name, array('description'=>'<b>Sitemap HTML</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>$aio_plugin_name, 'user'=>$gCurrentUser));
      }
    }
  }
}

//CF7 Add-on click5

if(esc_attr(get_option('click5_history_log_cf7-add-on-by-click5/cf7-addon-by-click5.php')) == "1"){
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  if(strpos($option, 'click5_cf7_addon_form_enable_') !== false) { 
    $form_post_id = intval(substr($option,strlen("click5_cf7_addon_form_enable_")));
    $form_post = WPCF7_ContactForm::find();
    $title = "";
    foreach($form_post as $form)
    {
      if($form->id == $form_post_id)
        $title = $form->title;
    }
    if($value != $old_value){
    if($value == true)
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Contact Form 7', 'user'=>$gCurrentUser)); 
    else
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Contact Form 7', 'user'=>$gCurrentUser)); 
    }
  }

  if(strpos($option, 'click5_cf7_addon_posting_url') !== false) { 
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>'<b>Posting URL</b> has been changed to:<br> '.$value,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Contact Form 7', 'user'=>$gCurrentUser)); 
    }
  }
}

//WPF Add-on click5

if(esc_attr(get_option('click5_history_log_wpf-add-on-by-click5/wpf-addon-by-click5.php')) == "1"){
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  if(strpos($option, 'click5_wpf_addon_form_enable_') !== false) { 
    $form_post_id = intval(substr($option,strlen("click5_wpf_addon_form_enable_")));
    $form_post = wpforms()->form->get();
    $title = "";
    foreach($form_post as $form)
    {
      if($form->ID == $form_post_id)
        $title = $form->post_title;
    }
    if($value != $old_value){
    if($value == true)
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to WPForms', 'user'=>$gCurrentUser)); 
    else
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to WPForms', 'user'=>$gCurrentUser)); 
    }
  }

  if(strpos($option, 'click5_wpf_addon_posting_url') !== false) { 
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>'<b>Posting URL</b> has been changed to:<br>'.$value,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to WPForms', 'user'=>$gCurrentUser)); 
    }
  }
}

//Ninja Forms Add-on click5

if(esc_attr(get_option('click5_history_log_click5-crm-add-on-to-ninja-forms/ninja-addon-by-click5.php')) == "1"){
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  if(strpos($option, 'click5_ninja_addon_form_enable_') !== false) { 
    $form_post_id = intval(substr($option,strlen("click5_ninja_addon_form_enable_")));
    $form_post = Ninja_Forms()->form()->get_forms();
    $title = "";
    foreach($form_post as $form)
    {
      if($form->get_id() == $form_post_id)
        $title = $form->get_settings()['title'];
    }
    if($value != $old_value){
    if($value == true)
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Ninja Forms', 'user'=>$gCurrentUser)); 
    else
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Ninja Forms', 'user'=>$gCurrentUser)); 
    }
  }

  if(strpos($option, 'click5_ninja_addon_posting_url') !== false) { 
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>'<b>Posting URL</b> has been changed to:<br>'.$value,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Ninja Forms', 'user'=>$gCurrentUser)); 
    }
  }
}

//Gravity Forms Add-on click5

if(esc_attr(get_option('click5_history_log_gf-add-on-by-click5/gf-addon-by-click5.php')) == "1"){
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  if(strpos($option, 'click5_gf_addon_form_enable_') !== false) { 
    $form_post_id = intval(substr($option,strlen("click5_gf_addon_form_enable_")));
    $form_post = GFAPI::get_forms();
    $title = "";
    foreach($form_post as $form)
    {
      if($form['id'] == $form_post_id)
        $title = $form['title'];
    }
    if($value != $old_value){
    if($value == true)
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been enabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Gravity Forms', 'user'=>$gCurrentUser)); 
    else
      $wpdb->insert($table_name, array('description'=>'Form <b>'.$title.'</b> has been disabled','date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Gravity Forms', 'user'=>$gCurrentUser)); 
    }
  }

  if(strpos($option, 'click5_gf_addon_posting_url') !== false) { 
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>'<b>Posting URL</b> has been changed to:<br>'.$value,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'click5 CRM add-on to Gravity Forms', 'user'=>$gCurrentUser)); 
    }
  }
}

//Sitemap click5
  if(strpos($option, 'click5_sitemap_urls_list') !== false) { 
    $old_data = json_decode($old_value);
    $new_data = json_decode($value);
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if(count($new_data) > 0 && count($old_data) > 0 && count($new_data) == count($old_data)) { 
      foreach($new_data as $new_data_item) {
        $update_item = false; 
        foreach($old_data as $old_data_item) {
          if( $new_data_item->ID == $old_data_item->ID ) {
            if($new_data_item->title != $old_data_item->title) {
              $update_item = true;
            }
            if($new_data_item->url != $old_data_item->url) {
              $update_item = true;
            }
            if($new_data_item->new_tab != $old_data_item->new_tab) {
              $update_item = true;
            }
            if($new_data_item->enabledHTML != $old_data_item->enabledHTML) {
              $update_item = true;
            }
            if($new_data_item->enabledXML != $old_data_item->enabledXML) {
              $update_item = true;
            }
            if($new_data_item->last_mod != $old_data_item->last_mod) {
              $update_item = true;
            }
            if($new_data_item->category->use_custom != $old_data_item->category->use_custom) {
              $update_item = true;
            } else {
              if($new_data_item->category->name != $old_data_item->category->name) {
                $update_item = true;
              }
            }
          }
        }
        if($update_item && esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {
          $wpdb->insert($table_name, array('description'=>'<b>' . $new_data_item->title . '</b> has been updated in Custom URLs list','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      }
    }


    if(count($new_data) > count($old_data)) {
      foreach($new_data as $new_data_item) {
        $new_item = true; 
        foreach($old_data as $old_data_item) {
          if( $new_data_item->ID == $old_data_item->ID ) {
            $new_item = false;
          }
        }
        if($new_item && esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {
          $wpdb->insert($table_name, array('description'=>'<b>' . $new_data_item->title . '</b> has been added to Custom URLs list','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      }
    }
    if(count($new_data) < count($old_data)) {
      foreach($old_data as $old_data_item) {
        $new_item = true; 
        foreach($new_data as $new_data_item) {
          if( $new_data_item->ID == $old_data_item->ID ) {
            $new_item = false;
          }
        }
        if($new_item && esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {
          $wpdb->insert($table_name, array('description'=>'<b>' .  $old_data_item->title . '</b> has been removed from Custom URLs list','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      }
    }
  }

  if(strpos($option, 'click5_sitemap_seo_') !== false) {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    if(strpos($option, 'click5_sitemap_seo_post_type_') !== false && $option != "click5_sitemap_seo_post_type_post" && $option != "click5_sitemap_seo_post_type_page") { 
      $data_seo = explode("_type_", $option);
      if($data_seo[1] == 'faq') {
        $data_seo[1] = 'FAQ';
      }
      if($old_value == "" && $value == "1") {
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>"XML Sitemap for <b>" . ucfirst($data_seo[1]) . "</b> has been turned on",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      } 
      if($old_value == "1" && $value == "") {
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>"XML Sitemap for <b>" . ucfirst($data_seo[1]) . "</b> has been turned off",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      }
    }

    if(strpos($option, 'click5_sitemap_seo_xml_') !== false && $option != "click5_sitemap_seo_xml_categories" && $option != "click5_sitemap_seo_xml_tags" && $option != "click5_sitemap_seo_xml_authors" && $option != "click5_sitemap_seo_xml_docs" 
    && $option != "click5_sitemap_seo_xml_videos" && $option != "click5_sitemap_seo_xml_images") { 
      $data_seo_cutom = explode("_xml_", $option);
      $data_seo = explode("_", $data_seo_cutom[1]);
      if(strpos($data_seo[0], '-') !== false) { 
        $data_seo[0] = explode("-", $data_seo[0])[1];
      }
      if($data_seo[0] == 'faq') {
        $data_seo[0] = 'FAQ';
      }
      if($old_value == "" && $value == "1") {
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>"XML Sitemap for <b>" . ucfirst($data_seo[0]) . "</b> has been turned on",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      } 
      if($old_value == "1" && $value == "") {
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>"XML Sitemap for <b>" . ucfirst($data_seo[0]) . "</b> has been turned off",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      }
    }

    
    $array_settings_sitemap_seo = array(
      array("click5_sitemap_seo_robots_txt", "XML Sitemap for <b>robots.txt</b>"),
      array("click5_sitemap_seo_sitemap_xml", "XML Sitemap for <b>sitemap.xml</b>"),
      array("click5_sitemap_seo_include_sitemap_xml", "Include <b>sitemap.xml URL in robots.txt</b>"),

      array("click5_sitemap_seo_post_type_post", "XML Sitemap for <b>Posts</b>"),
      array("click5_sitemap_seo_post_type_page", "XML Sitemap for <b>Pages</b>"),

      array("click5_sitemap_seo_xml_categories", "XML Sitemap for <b>Categories</b>"),
      array("click5_sitemap_seo_xml_tags", "XML Sitemap for <b>Tags</b>"),
      array("click5_sitemap_seo_xml_authors", "XML Sitemap for <b>Authors</b>"),

      array("click5_sitemap_seo_xml_images", "XML Sitemap for <b>Images</b>"),
      array("click5_sitemap_seo_xml_docs", "XML Sitemap for <b>Documents</b>"),
      array("click5_sitemap_seo_xml_videos", "XML Sitemap for <b>Videos</b>"),
    );
    
    foreach($array_settings_sitemap_seo as $setting_sitemap_seo) {
      if($setting_sitemap_seo[0] == $option && $old_value == "" && $value == "1") {
        $description_sitemap = $setting_sitemap_seo[1] . " has been turned on";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      } else if($setting_sitemap_seo[0] == $option && $old_value == "1" && $value == "") {
        $description_sitemap = $setting_sitemap_seo[1] . " has been turned off";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      }
    }
  }

  if(strpos($option, 'click5_sitemap_blacklisted_array') !== false || strpos($option, 'click5_sitemap_seo_blacklisted_array') !== false) {
    $old_data = json_decode($old_value);
    $new_data = json_decode($value);
    global $gCurrentUser;
    global $wpdb;
    global $sitemapCurrentUser;
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser) && !is_null($sitemapCurrentUser->data->user_login))
        $usr = $sitemapCurrentUser->data->user_login;
    $table_name = $wpdb->prefix . "c5_history";
    if(count($new_data) > count($old_data)) {
      foreach($new_data as $new_data_item) {
        $new_item = true; 
        foreach($old_data as $old_data_item) {
          if( $new_data_item->ID == $old_data_item->ID ) {
            $new_item = false;
          }
        }
        if($new_item) {
          if(strpos($option, 'click5_sitemap_blacklisted_array') !== false) {
            if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
              $wpdb->insert($table_name, array('description'=>'<b>' . $new_data_item->post_title . '</b> has been added to HTML blacklist','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$usr));
            }
          }
          if(strpos($option, 'click5_sitemap_seo_blacklisted_array') !== false) {
            if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
              $wpdb->insert($table_name, array('description'=>'<b>' . $new_data_item->post_title . '</b> has been added to XML blacklist','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$usr));
            }
          }
        }
      }
    }
    if(count($new_data) < count($old_data)) {
      foreach($old_data as $old_data_item) {
        $new_item = true; 
        foreach($new_data as $new_data_item) {
          if( $new_data_item->ID == $old_data_item->ID ) {
            $new_item = false;
          }
        }
        if($new_item) {
          if(strpos($option, 'click5_sitemap_blacklisted_array') !== false) {
            if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
              $wpdb->insert($table_name, array('description'=>'<b>' .  $old_data_item->post_title . '</b> has been deleted from HTML blacklist','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$usr));
            }
          }
          if(strpos($option, 'click5_sitemap_seo_blacklisted_array') !== false) {
            if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
              $wpdb->insert($table_name, array('description'=>'<b>' .  $old_data_item->post_title . '</b> has been deleted from XML blacklist','date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$usr));
            }           
          }
        }
      }
    }
  }

  if(strpos($option, 'click5_sitemap_html_blog_treat') !== false) {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history"; 
    if($option != "click5_sitemap_html_blog_treat_post" && $option != "click5_sitemap_html_blog_treat_page") { 
      $data_seo = explode("_treat_", $option);
      if($data_seo[1] == 'faq') {
        $data_seo[1] = 'FAQ';
      }
      if($old_value == "" && $value == "1") {
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {  
          $wpdb->insert($table_name, array('description'=>"Grouping by <b>" . ucfirst($data_seo[1]) . "</b> has been enabled",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));  
        }
      } 
      if($old_value == "1" && $value == false) {
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {  
          $wpdb->insert($table_name, array('description'=>"Grouping by <b>" . ucfirst($data_seo[1]) . "</b> has been disabled",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }       
      }
    }

    $array_settings_sitemap_url = array(
      array("click5_sitemap_html_blog_treat_post", "Grouping by <b>Posts</b>"),
      array("click5_sitemap_html_blog_treat_page", "Grouping by <b>Pages</b>")
    );

    foreach($array_settings_sitemap_url as $setting_sitemap_name) {
      if($setting_sitemap_name[0] == $option && $old_value == "" && $value == true) {
        $description_sitemap = $setting_sitemap_name[1] . " has been enabled";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {  
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      } else if($setting_sitemap_name[0] == $option && $old_value == "1" && $value == false) {
        $description_sitemap = $setting_sitemap_name[1] . " has been disabled";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {  
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      }
    }  
  }

  if(strpos($option, 'click5_sitemap_url') !== false) {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history"; 
    $array_settings_sitemap_url = array(
      array("click5_sitemap_url_target_blanc", "<b>Open links in new tab</b>")
    );

    foreach($array_settings_sitemap_url as $setting_sitemap_name) {
      if($setting_sitemap_name[0] == $option && $old_value == "" && $value == true) {
        $description_sitemap = $setting_sitemap_name[1] . " has been turned on";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      } else if($setting_sitemap_name[0] == $option && $old_value == "1" && $value == false) {
        $description_sitemap = $setting_sitemap_name[1] . " has been turned off";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }     
      }
    }  
  }

  if(strpos($option, 'click5_sitemap_order_list_old') !== false) {
    if($old_value != $value) {
      global $gCurrentUser;
      global $wpdb;
      $table_name = $wpdb->prefix . "c5_history"; 
      if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
        $wpdb->insert($table_name, array('description'=>"<b>HTML Sitemap</b> Order has been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
      }  
    }
  }  

  if(strpos($option, 'click5_sitemap_display') !== false) {
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history"; 
    if($option != "click5_sitemap_display_post" && $option != "click5_sitemap_display_page" && $option != "click5_sitemap_display_tag_tax" && $option != "click5_sitemap_display_cat_tax" && $option != "click5_sitemap_display_authors_tax") { 
      $data_seo = explode("_display_", $option);
      if($data_seo[1] == 'faq') {
        $data_seo[1] = 'FAQ';
      }
      if($old_value == "" && $value == "1" && esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {
        $wpdb->insert($table_name, array('description'=>"HTML Sitemap <b>" . ucfirst($data_seo[1]) . "</b> has been turned on",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
      } 
      if($old_value == "1" && $value == false && esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") {
        $wpdb->insert($table_name, array('description'=>"HTML Sitemap <b>" . ucfirst($data_seo[1]) . "</b> has been turned off",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
      }
    }

    $array_settings_sitemap_names = array(
      array("click5_sitemap_display_post", "<b>Posts</b>"),
      array("click5_sitemap_display_page", "<b>Pages</b>"),
      array("click5_sitemap_display_tag_tax", "<b>Tags</b>"),
      array("click5_sitemap_display_cat_tax", "<b>Categories</b>"),
      array("click5_sitemap_display_authors_tax", "<b>Authors</b>")
    );
    
    foreach($array_settings_sitemap_names as $setting_sitemap_name) {
      if($setting_sitemap_name[0] == $option && $old_value == "" && $value == "1") {
        $description_sitemap = "HTML Sitemap " . $setting_sitemap_name[1] . " has been turned on";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }
      } else if($setting_sitemap_name[0] == $option && $old_value == "1" && $value == null) {
        $description_sitemap = "HTML Sitemap " . $setting_sitemap_name[1] . " has been turned off";
        if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description_sitemap,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
        }  
      }
    }

    if($option == "click5_sitemap_display_columns") {
      if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
        $wpdb->insert($table_name, array('description'=>"Display in columns has been set to <b>" . $value . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
      }   
    }

    if($option == "click5_sitemap_display_style") {
      if($value == "merge") {
        $text = "Merge into one list";
      } 
      if($value == "group") {
        $text = "Split and group by post types";
      }
      if(esc_attr(get_option('click5_history_log_sitemap-by-click5/sitemap-by-click5.php')) == "1") { 
        $wpdb->insert($table_name, array('description'=>"Grouping Type has been set to <b>" . $text . "</b>",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Sitemap by click5', 'user'=>$gCurrentUser));
      }
    }
  }
  
  if (strpos($option, 'click5_disable_comments_display') !== false) {
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history"; 
    $array_settings_names = array(
      array("click5_disable_comments_display_globally", "<b>Globally"),
      array("click5_disable_comments_display_post", "<b>Post"),
      array("click5_disable_comments_display_page", "<b>Page"),
      array("click5_disable_comments_display_attachment", "<b>Attachment"),
      array("click5_disable_comments_display_rpc", "<b>XML-RPC"),
      array("click5_disable_comments_display_api", "<b>REST API")
    );

    foreach($array_settings_names as $setting_name) {
      if($setting_name[0] == $option && $old_value == "" && $value == "1") {
        $description = $setting_name[1] . " Comments</b> has been turned on";
        if(esc_attr(get_option('click5_history_log_disable-comments-by-click5/disable-comments-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Disable Comments by click5', 'user'=>wp_get_current_user()->user_login));
        }       
      } else if($setting_name[0] == $option && $old_value == "1" && $value == null) {
        $description = $setting_name[1] . " Comments</b> has been turned off";
        if(esc_attr(get_option('click5_history_log_disable-comments-by-click5/disable-comments-by-click5.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>$description,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Disable Comments by click5', 'user'=>wp_get_current_user()->user_login));
        }
      }
    }
  }

  if((esc_attr(get_option('click5_history_log_better-search-replace/better-search-replace.php')) == "1" && is_plugin_active('better-search-replace/better-search-replace.php')) || (esc_attr(get_option('click5_history_log_better-search-replace-pro/better-search-replace.php')) == "1" && is_plugin_active('better-search-replace-pro/better-search-replace.php'))){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";

    $pro = "";
    if(is_plugin_active('better-search-replace-pro/better-search-replace.php'))
      $pro = "Pro";

    if(strpos($option, 'bsr_license_key') !== false){
      if($old_value != $value){
        $wpdb->insert($table_name, array('description'=>"<b>License key</b> has been changed",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Better Search Replace '.$pro, 'user'=>$gCurrentUser));
      }
    }

    if(strpos($option, 'bsr-license-status') !== false){
      if((esc_attr(get_option('click5_history_log_better-search-replace/better-search-replace.php')) == "1" && is_plugin_active('better-search-replace/better-search-replace.php')) || (esc_attr(get_option('click5_history_log_better-search-replace-pro/better-search-replace.php')) == "1" && is_plugin_active('better-search-replace-pro/better-search-replace.php'))){
        if($old_value != $value){
          if($value == "invalid")
            $wpdb->insert($table_name, array('description'=>"<b>License key</b> has been deactivated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Better Search Replace '.$pro, 'user'=>$gCurrentUser));
          else if($value == "valid")
          $wpdb->insert($table_name, array('description'=>"<b>License key</b> has been activated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Better Search Replace '.$pro, 'user'=>$gCurrentUser));
        }
      }
    }
  }

  if(strpos($option, 'googlesitekit_analytics_settings') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser))
      $usr = "WordPress Core";
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>"<b>Analytics settings</b> have been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Site Kit by Google', 'user'=>$usr));
    }
  }

  if(strpos($option, 'googlesitekit_search-console_settings') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser))
      $usr = "WordPress Core";
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>"<b>Search Console settings</b> have been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Site Kit by Google', 'user'=>$usr));
    }
  }

  if(strpos($option, 'googlesitekit_adsense_settings') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser))
      $usr = "WordPress Core";
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>"<b>AdSense settings</b> have been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Site Kit by Google', 'user'=>$usr));
    }
  }

  if(strpos($option, 'googlesitekit_pagespeed-insights_settings') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser))
      $usr = "WordPress Core";
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>"<b>PageSpeed Insights settings</b> have been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Site Kit by Google', 'user'=>$usr));
    }
  }

  if(strpos($option, 'googlesitekit_optimize_settings') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser))
      $usr = "WordPress Core";
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>"<b>Optimize settings</b> have been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Site Kit by Google', 'user'=>$usr));
    }
  }

  if(strpos($option, 'googlesitekit_tag-manager_settings') !== false){
    global $gCurrentUser;
    global $wpdb;
    $table_name = $wpdb->prefix . "c5_history";
    $usr = $gCurrentUser;
    if(is_null($gCurrentUser))
      $usr = "WordPress Core";
    if($value != $old_value){
      $wpdb->insert($table_name, array('description'=>"<b>Tag Manager settings</b> have been updated",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Site Kit by Google', 'user'=>$usr));
    }
  }

}, 10, 3 );

function click5_history_log_load_plugin_textdomain() {
  load_plugin_textdomain( 'history-log-by-click5', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
}
add_action( 'plugins_loaded', 'click5_history_log_load_plugin_textdomain' );

function click5_history_log_settings_page() {
  
		
?>

<h1 class="click5_history_log_heading"><?php _e('History Log by click5', 'history-log-by-click5'); ?>&nbsp;<span class="version">v<?php echo click5_history_log_VERSION; ?></span></h1>

<?php
            if( isset( $_GET[ 'tab' ] ) ) {
                $active_tab = sanitize_key($_GET[ 'tab' ]);
            } else {
              $active_tab = 'log';
            }
?>

<h2 class="nav-tab-wrapper">
    <a href="?page=history-log-by-click5%2Fhistory-log-by-click5.php&tab=log" class="nav-tab <?php echo $active_tab == 'log' ? 'nav-tab-active' : ''; ?>"><?php _e('History Log', 'history-log-by-click5'); ?></a>
    <a href="?page=history-log-by-click5%2Fhistory-log-by-click5.php&tab=settings" class="nav-tab <?php echo $active_tab == 'settings' ? 'nav-tab-active' : ''; ?>"><?php _e('Settings', 'history-log-by-click5'); ?></a>
</h2>

<div class="wrap click5_history_log_wrapper_content_settings">
<div class="content-left">
<?php
      $verification_token = md5(uniqid(rand(), true));
      $cur_user_id = wp_get_current_user()->user_login;
      update_option('click5_history_log_token_'.$cur_user_id, $verification_token);
?>
<input type="hidden" id="verification_token" value="<?php echo esc_attr($verification_token); ?>" />
<input type="hidden" id="user_identificator" value="<?php echo esc_attr($cur_user_id); ?>" />

<form method="post" action="">
<?php wp_nonce_field( 'click5_history_log_nonce','click5_history_log_nonce' ); ?>
<?php if ($active_tab == 'log'): ?>  
    <?php settings_fields( 'click5_history-log' ); ?>
    <?php do_settings_sections( 'click5_history-log' ); ?>
    <?php
    $db_history = new Click5_Grid();
    $db_history->prepare_items();
		?>
		<div class="wrap grid-margin">
			<h1><?php echo esc_html( get_admin_page_title() ); ?></h1>
      <?php if(isset($_SESSION['search_param'])){?>
        <?php if($_SESSION['search_param']!= ""){?>
      <span style="margin-left: 130px; margin-right:auto; float:left; transform: translateY(-23px);  " id="searchInfo" class="subtitle"><?php echo (isset($_SESSION['search_param']))?"Search results for: <b>". $_SESSION['search_param'] . "</b>":'';?> </span>
    <?php } ?>
    <?php } ?>
      <br/>
      <div class="wrap table-block grid-margin">
      <div style="margin-left: auto; margin-right:0px; float:right; ">      
            <p class="search-box">
            <input style="transform: translateY(-23px); border-radius:4px; border-style:solid; border-color:#8c8f94; border-width: 1px; min-height: 30px; font-size:14px; width:192px;" id="searchRecords" name="searchRecords" value = "<?php echo (isset($_SESSION['search_param']))?$_SESSION['search_param']:'';?>">
            <input style="transform: translateY(-24px);" value="Search Logs" class="button button-secondary" type="submit" name="search_button" />
            </p>
            <br/>
        </div>
        <div class="filter_slot">
          <form method="GET">
            <?php wp_nonce_field( 'click5_history_log_nonce','click5_history_log_nonce' ); ?>
                      <label for="filter-by-month" class="screen-reader-text">Filter by month</label>
            <select id="filter-by-month" name="filter-by-month">
              <option value="0" <?php if (!isset($_SESSION["cookie-filter-by-month"]) || $_SESSION["cookie-filter-by-month"] == "0") { echo ' selected="selected"'; } ?>>All months</option>
              <?php 
                global $wpdb;
                $table_name = $wpdb->prefix . "c5_history";
                $query = "SELECT * FROM $table_name";
                $results = $wpdb->get_results($query);
                $valid_dates = array();
                foreach($results as $result_item) {
                  $add_new_option = true;
                  $time_array = explode("-", $result_item->date);
                  $date_option = $time_array[0] . $time_array[1];
                  foreach($valid_dates as $valid_item) {
                    if($valid_item == $date_option) {
                      $add_new_option = false;
                    }
                  }
                  if($add_new_option) {
                    array_push($valid_dates, $date_option);   
                  }
                }
                arsort($valid_dates);
                foreach($valid_dates as $valid_dates_option_items) {
                  $display_string = "";
                  $month_maps = array(
                    array('01', 'January'),
                    array('02', 'February'),
                    array('03', 'March'),
                    array('04', 'April'),
                    array('05', 'May'),
                    array('06', 'June'),
                    array('07', 'July'),
                    array('08', 'August'),
                    array('09', 'September'),
                    array('10', 'October'),
                    array('11', 'November'),
                    array('12', 'December')
                  );
                  foreach($month_maps as $month_maps_item) {
                    if($month_maps_item[0] == substr($valid_dates_option_items, -2)) {
                      $display_string = $month_maps_item[1] . " " . substr($valid_dates_option_items, 0, -2);
                    }
                  }
                  ?><option value=<?php echo esc_attr($valid_dates_option_items) ?> <?php if (isset($_SESSION["cookie-filter-by-month"]) && $_SESSION["cookie-filter-by-month"] == $valid_dates_option_items ) { echo ' selected="selected"'; } ?>><?php echo esc_attr($display_string) ?></option><?php
                }
              ?>
            </select>
            <input type="hidden" name="max_page" value=<?php echo esc_attr($db_history->_pagination_args['total_pages']) ?> />
            <label for="filter-by-user" class="screen-reader-text">Filter by user</label>
            <select id="filter-by-user" name="filter-by-user">
              <option <?php if (!isset($_SESSION["cookie-filter-by-user"]) && $_SESSION["cookie-filter-by-user"] == "all") { echo ' selected="selected"'; } ?> value="all">All users</option>
              <?php 
                global $wpdb;
                $table_name = $wpdb->prefix . "c5_history";
                $user_tab_name = $wpdb->prefix . 'users'; 
                $query = "SELECT * FROM $table_name " . " WHERE 1=1 AND user IS NOT NULL ";
                $query_user = "SELECT * FROM $user_tab_name";
                $results = $wpdb->get_results($query);
                $results_user = $wpdb->get_results($query_user);
                $user_array = array();
                $user_roles = array("Global","Administrator");
                foreach($results as $results_item) {
                  $add_element = true;
                  foreach($user_array as $user_item) { 
                    if($user_item == $results_item->user) {
                      $add_element = false;
                    }
                  }
                  if($add_element && $results_item->user != "") {
                    array_push($user_array, $results_item->user);
                  }
                }
                $user_list_items = array();
                foreach($user_array as $user_element) { 
                    $name_user = "";
                    $user_login = "";
                    foreach($results_user as $user_single) {
                      if($user_single->user_login == $user_element) {
                        $name_user = $user_single->display_name;
                        $user_id = $user_single->ID;
                        $user_login = $user_single->user_login;
                        break;
                      }
                    }
                    if($name_user == "") {
                      $name_user = $user_element;
                    }
                    $user_meta = get_user_by("login",$user_login);
                    $user_role = null;
                    if(isset($user_meta->roles))
                    {
                      $user_role = ucfirst($user_meta->roles[0]);
                      if($user_role!= null)
                      {
                        if(in_array($user_role, $user_roles) == false){
                          array_push($user_roles,$user_role );
                        }
                      }
                    }
                    if(is_null($user_role))
                    {
                      $user_role="Global";
                    }
                    array_push($user_list_items, array($user_element, $name_user, $user_role));
                }
                usort($user_list_items, function($x, $s) {
                  return strcmp(strtolower($x[1]), strtolower($s[1]));
                });
                        
                if(count($user_list_items)>=10)
                {
                  foreach ($user_roles as $role)
                  {
                    if($role == "Global")
                    {
                      foreach($user_list_items as $user_list_item) {
                        if($user_list_item[2] == $role)
                        {
                        ?>
                        <option value=<?php echo str_replace(" ","%%%", esc_attr($user_list_item[0]));  ?> <?php if (isset($_SESSION["cookie-filter-by-user"]) && $_SESSION["cookie-filter-by-user"] == $user_list_item[0]) { echo ' selected="selected"'; } ?> ><?php if(strlen(esc_attr($user_list_item[1])) > 15) { echo substr(esc_attr($user_list_item[1]), 0, 15) . "..."; } else { echo esc_attr($user_list_item[1]); } ?></option><?php
                        }
                        elseif($role == "Other" && $user_list_item[2] ==null){
                          ?>
                        <option value=<?php echo str_replace(" ","%%%", esc_attr($user_list_item[0]));  ?> <?php if (isset($_SESSION["cookie-filter-by-user"]) && $_SESSION["cookie-filter-by-user"] == $user_list_item[0]) { echo ' selected="selected"'; } ?> ><?php if(strlen(esc_attr($user_list_item[1])) > 15) { echo substr(esc_attr($user_list_item[1]), 0, 15) . "..."; } else { echo esc_attr($user_list_item[1]); } ?></option><?php
                        }
                      }
                    }
                    
                  }
                  foreach ($user_roles as $role)
                  {
                    if($role != "Global"){
                    ?>
                    <optgroup label=<?php echo $role."s" ?>>
                      <?php 
                    foreach($user_list_items as $user_list_item) {
                      if($user_list_item[2] == $role)
                      {
                      ?>
                      <option value=<?php echo str_replace(" ","%%%", esc_attr($user_list_item[0]));  ?> <?php if (isset($_SESSION["cookie-filter-by-user"]) && $_SESSION["cookie-filter-by-user"] == $user_list_item[0]) { echo ' selected="selected"'; } ?> ><?php if(strlen(esc_attr($user_list_item[1])) > 15) { echo substr(esc_attr($user_list_item[1]), 0, 15) . "..."; } else { echo esc_attr($user_list_item[1]); } ?></option><?php
                      }
                      elseif($role == "Other" && $user_list_item[2] ==null){
                        ?>
                      <option value=<?php echo str_replace(" ","%%%", esc_attr($user_list_item[0]));  ?> <?php if (isset($_SESSION["cookie-filter-by-user"]) && $_SESSION["cookie-filter-by-user"] == $user_list_item[0]) { echo ' selected="selected"'; } ?> ><?php if(strlen(esc_attr($user_list_item[1])) > 15) { echo substr(esc_attr($user_list_item[1]), 0, 15) . "..."; } else { echo esc_attr($user_list_item[1]); } ?></option><?php
                      }
                    }
                  }
                  }
                }
                else
                {
                  foreach($user_list_items as $user_list_item) {
                    ?>
                    <option value=<?php echo str_replace(" ","%%%", esc_attr($user_list_item[0]));  ?> <?php if (isset($_SESSION["cookie-filter-by-user"]) && $_SESSION["cookie-filter-by-user"] == $user_list_item[0]) { echo ' selected="selected"'; } ?> ><?php if(strlen(esc_attr($user_list_item[1])) > 15) { echo substr(esc_attr($user_list_item[1]), 0, 15) . "..."; } else { echo esc_attr($user_list_item[1]); } ?></option><?php
                  }
                }
              ?>
            </select>
            <label for="filter-by-module" class="screen-reader-text">Filter by plugin/module</label>
            <select id="filter-by-module" name="filter-by-module">
              <option value="all" <?php if (!isset($_SESSION["cookie-filter-by-module"]) || $_SESSION["cookie-filter-by-module"] == "all") { echo ' selected="selected"'; } ?>>All plugins/modules</option>
              <?php 
                $mod_array = array();
                foreach($results as $results_single_item) { 
                  $add_mod = true;
                  foreach($mod_array as $mod_item) { 
                    if($mod_item == $results_single_item->plugin) {
                      $add_mod = false;
                    }
                  }
                  if($add_mod) {
                    array_push($mod_array, $results_single_item->plugin);
                  }
                }
                usort($mod_array, function($x,$s){
                  return strcmp(strtolower($x), strtolower($s));
                });
                foreach($mod_array as $mod_element) { 
                ?><option value=<?php echo str_replace(" ","%%%", esc_attr($mod_element)); ?> <?php if (isset($_SESSION["cookie-filter-by-module"]) && $_SESSION["cookie-filter-by-module"] == $mod_element) { echo ' selected="selected"'; } ?> ><?php if(strlen(esc_attr($mod_element)) > 30) { echo substr(esc_attr($mod_element), 0, 30) . "..."; } else { echo esc_attr($mod_element); } ?></option><?php
              }
              ?>
            </select>
            <?php wp_nonce_field( 'click5_filter_nonce','click5_filter_nonce' ); ?>
            <input value="Filter" class="button button-secondary" type="submit" name="filter_button"/>
          </form>
        </div>
        <?php $db_history->display(); ?>
      </div>
		</div>
    <div id="poststuff">
      <div id="post-body-content">     
      </div>
    </div>
    <?php elseif( $active_tab == 'settings' ): ?>
    <?php settings_fields( 'click5_sitemap_seo' ); ?>
    <?php do_settings_sections( 'click5_sitemap_seo' ); ?>
    <div id="poststuff">
      <div id="post-body-content" >
      <form action="" method="post">
          <?php wp_nonce_field( 'click5_history_log_nonce','click5_history_log_nonce' ); ?>
          <div class="postbox" style="margin-right: 20px!important">
            <h3 class="hndle"><span><?php _e('History Log Settings', 'sitemap-by-click5'); ?></span></h3>
            <div class="inside">
              <p><strong style="margin-left: 15px">Store History Log Data for</strong></p>
              <table class="form-table">
                <tbody>
                  <tr>
                    <select id="click5_history_log_store_time" name="click5_history_log_store_time" style="margin-left: 15px;width: 245px;">
                      <!--<option value="day" <?php echo (esc_attr( get_option('click5_log_store_time') ) == 'day' ? 'selected' : ''); ?>>1 day</option>-->
                      <option value="week" <?php echo (esc_attr( get_option('click5_log_store_time') ) == 'week' ? 'selected' : ''); ?>>1 week</option>
                      <option value="month" <?php echo (esc_attr( get_option('click5_log_store_time') ) == 'month' ? 'selected' : ''); ?>>1 month</option>
                      <option value="3_month" <?php echo (esc_attr( get_option('click5_log_store_time') ) == '3_month' ? 'selected' : ''); ?>>3 months</option>
                      <option value="6_month" <?php echo (esc_attr( get_option('click5_log_store_time') ) == '6_month' ? 'selected' : ''); ?>>6 months</option>
                      <option value="12_month" <?php echo (esc_attr( get_option('click5_log_store_time') ) == '12_month' ? 'selected' : ''); ?>>12 months</option>
                      <option value="indefinitely" <?php echo (esc_attr( get_option('click5_log_store_time') ) == 'indefinitely' ? 'selected' : ''); ?>>Indefinitely (Not Recommended)</option>
                    </select>
                  </tr>
                </tbody>
              </table>
              <input value="Save Changes" style="margin-left: 15px" class="button button-primary" type="submit" name="save_button"/>
              <br/>
              <div style="margin-left: 15px">
                <b><h4>Purge History Log Data</h4></b>
                Warning: This will delete all history logs from your database.
                <br/>
              </div>            
              <br/>
              <input value="Purge Data" style="margin-left: 15px" type="button" class="button button-outline-primary" id ="myBtn" name="myBtn" onclick='btnClick()'/>

              <div id="c5ConfirmModal" class="c5modal">
                <!-- Modal content -->
                <div class="c5modal-content">
                  <span onclick="closeModal()" class="c5close">&times;</span>
                  <p style="margin-left: 15px">If you want to delete logs, enter 'DELETE' below and press Purge Data.</p>
                  <input style="margin-left: 15px" id="confirmDelete" name="confirmDelete" />
                  <div name="confirm-delete-message" style="display: none; color: red; margin-left: 15px;">
                      <p>The text you entered is incorrect</p>
                  </div>
                  <br/>
                  <br/>
                  
                  <input value="Purge Data" style="margin-left: 15px" type="submit" class="button button-primary" name="save_button_op"/>
                  <input value="Cancel" style="margin-left: 15px" type="submit" class="button button-outline-primary" name="cancel_button_op"/>
                </div>
                </div>
            </div>
          </div>
          <div class="plugin-block">
            <h1><b style="margin-left: 5px"><i class="bi bi-check"></i> Plugins</b></h1>               
            <div style="margin-right: 20px!important">
              <div class="table-block">
              <?php
                $db_history_plugins = new Click5_Grid_Plugins();
                $db_history_plugins->prepare_items();
                $db_history_plugins->display();
              ?>
              </div>
            </div>
          </div>
        </form>
      </div>
    </div>
    <?php endif; ?>
</form>
</div>
<div class="content-right">
      <div id="poststuff">
        <div id="post-body-content">
            <div class="postbox">
              <h3 class="hndle"><span>Plugin Support</span></h3>
              <div class="inside">
                <p>Visit our <a href="http://wordpress.org/support/plugin/history-log-by-click5" target="_blank" rel="nofollow">community forum</a> to find answers to common issues, ask questions, submit bug reports, feature suggestions and other tips about our plugin.</p>
                <p>Please consider supporting us by <a href="https://wordpress.org/support/plugin/history-log-by-click5/reviews/?filter=5" target="_blank" rel="nofollow">rating this plugin</a>. Thanks!</p>
              </div>
            </div>
            <div class="postbox with-image">
              <a href="https://click5crm.com/?utm_source=history-plugin&utm_medium=sidebar&utm_campaign=wp-plugins" target="_blank" rel="nofollow">
                <img src="<?php echo plugin_dir_url( __FILE__ ).'assets/banner-300x515-sitemap-plugin.png'; ?>" alt="click5crm">
              </a>
            </div>
            <div class="postbox">
              <h3 class="hndle"><span>Our Other WordPress Plugins</span></h3>
              <div class="inside">
                <p><strong><a href="https://wordpress.org/plugins/sitemap-by-click5/" target="_blank" rel="nofollow">Sitemap by click5</a></strong></p>
                <p>Best plugin to generate and customize HTML & XML sitemaps for your website or blog.</p>
                <p><strong><a  href="https://wordpress.org/plugins/search/click5/" target="_blank" rel="nofollow">and more...</a</strong></p>
              </div>
            </div>
        </div>
      </div>
</div>
</div>
<?php }

function click5_history_log_init_admin_scripts() {
  $screen = get_current_screen();
  $version = click5_history_log_DEV_MODE ? time() : click5_history_log_VERSION;
  if(strpos($screen->base, 'history-log-by-click5') !== false) {
    wp_enqueue_style( 'click5_history_log_css_admin', plugins_url('/css/admin/index.css', __FILE__), array(), $version);
    wp_enqueue_script( 'click5_sitemap_js_admin', plugins_url('/js/index.js', __FILE__), array(), $version);
  }
  wp_localize_script( 'jquery', 'c5resturl', array('wpjson' => get_rest_url()) );

}

add_action('admin_enqueue_scripts', 'click5_history_log_init_admin_scripts');
function click5_history_log_uninstallFunction() {
  $current_user = wp_get_current_user();
  delete_option('click5_history_log_authentication_token_'.wp_get_current_user()->user_login);
}
register_uninstall_hook(__FILE__, 'click5_history_log_uninstallFunction');

add_filter( 'wp_ajax_wordfence_saveOptions', 'click5_wordfence_saveOptions' );
function click5_wordfence_saveOptions( ) {
  if (!empty($_POST['changes']) && ($changes = json_decode(stripslashes($_POST['changes']), true)) !== false) {
    $arrayKeys = array_keys($changes);
    foreach($arrayKeys as $value)
    {
      if($value == 'wafStatus')
      {
        $wafValue = $changes[$value];
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
          $wpdb->insert($table_name, array('description'=>"<b>Wordfence Firewall Status</b> has been changed to: " . $wafValue,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
        }
      }
      else
      {
        $optionVal = $changes[$value];
        global $gCurrentUser;
        global $wpdb;
        $table_name = $wpdb->prefix . "c5_history";
        if($value == "alertOn_block") {
          if($optionVal) {
            $optVal = "<b>turned on</b>";
          } 
          if(!$optionVal) {
            $optVal = "<b>turned off</b>";
          }
          if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
            $wpdb->insert($table_name, array('description'=>"Alert when an IP address is blocked has been " . $optVal,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
          }       
        }
        if($value == "alertOn_lostPasswdForm") {
          if($optionVal) {
            $optVal = "<b>turned on</b>";
          } 
          if(!$optionVal) {
            $optVal = "<b>turned off</b>";
          }
          if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
            $wpdb->insert($table_name, array('description'=>'Alert when the "lost password" form is used for a valid user has been ' . $optVal,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
          }
        }
        if($value == "alertOn_wordfenceDeactivated") {
          if($optionVal) {
            $optVal = "<b>turned on</b>";
          } 
          if(!$optionVal) {
            $optVal = "<b>turned off</b>";
          }
          if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
            $wpdb->insert($table_name, array('description'=>'Email if Wordfence is deactivated has been ' . $optVal,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
          }
        }
        if($value == "loginSecurityEnabled") {
          if($optionVal) {
            $optVal = "<b>turned on</b>";
          } 
          if(!$optionVal) {
            $optVal = "<b>turned off</b>";
          }
          if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
            $wpdb->insert($table_name, array('description'=>'Brute Force Protection has been ' . $optVal,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
          }       
        }
        if($value == "scanType") {
          if($optionVal == "limited") {
            $optVal = "<b>Limited Scan</b>";
          } 
          if($optionVal == "standard") {
            $optVal = "<b>Standard Scan</b>";
          } 
          if($optionVal == "highsensitivity") {
            $optVal = "<b>High Sensitivity</b>";
          } 
          if($optionVal == "custom") {
            $optVal = "<b>Custom Scan</b>";
          }
          if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
            $wpdb->insert($table_name, array('description'=>'Scan Options have been changed to ' . $optVal,'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
          }       
        }
      }
    }
  }
}
add_filter('wp_ajax_wordfence_scan', 'click5_wordfence_scan');
function click5_wordfence_scan( ) {
   global $gCurrentUser;
   global $wpdb;
   $table_name = $wpdb->prefix . "c5_history";
  if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
    $wpdb->insert($table_name, array('description'=>"<b>Wordfence</b> scan has been launched",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser)); 
  }   
}
add_filter('wp_ajax_wordfence_killScan', 'click5_wordfence_killScan');
function click5_wordfence_killScan( ) {
   global $gCurrentUser;
   global $wpdb;
   $table_name = $wpdb->prefix . "c5_history";
  if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
    $wpdb->insert($table_name, array('description'=>"<b>Wordfence</b> scan has been stopped",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
  }  
}
add_filter('wp_ajax_wordfence_restoreDefaults', 'click5_wordfence_restoreDefaults');
function click5_wordfence_restoreDefaults( ) {
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  if(esc_attr(get_option('click5_history_log_wordfence/wordfence.php')) == "1") { 
    $wpdb->insert($table_name, array('description'=>"<b>Wordfence</b> default settings has been restored",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Wordfence', 'user'=>$gCurrentUser));
  }
}

function click5_wp_login( $user_login, $user ) {
  // Display Name> successfully logged in
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"<b>" . $user->data->display_name . "</b> successfully logged in",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$user_login));
}
add_action('wp_login', 'click5_wp_login', 10, 2);

add_action('future_to_publish', 'click5_wp_future_to_publish');
function click5_wp_future_to_publish( $postid ) {
  $post_data = get_post($postid);
  global $gCurrentUser;
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  if($post_data->post_type == "post") {
    $wpdb->insert($table_name, array('description'=>"Post <b>" . $post_data->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Posts', 'user'=>'WordPress Core'));
  }
  if($post_data->post_type == "page") {
    $wpdb->insert($table_name, array('description'=>"Page <b>" . $post_data->post_title . "</b>  has been published",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'Pages', 'user'=>'WordPress Core'));
  }
}

add_action('profile_update', 'click5_password_reset', 10, 3);
function click5_password_reset($user_id, $old_user_data, $userdata) {
  global $wpdb;
  global $gCurrentUser;
  $new_pass = $userdata["user_pass"];
  $old_pass = $old_user_data->data->user_pass;
  if($old_pass != $new_pass) {
    $table_name = $wpdb->prefix . "c5_history";
    $wpdb->insert($table_name, array('description'=>"User <b>" . $userdata["display_name"] . "</b> set new password",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$gCurrentUser));
  }
}


add_action('after_password_reset', 'click5_after_password_reset', 10, 2);
function click5_after_password_reset($user_data, $pass) {
  global $wpdb;
  $table_name = $wpdb->prefix . "c5_history";
  $wpdb->insert($table_name, array('description'=>"User <b>" . $user_data->display_name . "</b> reset password",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$user_data->user_login));
}

/*
add_action( 'register_new_user', "click5_register_new_user",10,2 );
function click5_register_new_user(int $user_id) {
  global $wpdb;
  $new_user_name = $wpdb->query( $wpdb->prepare( "SELECT display_name FROM " . $wpdb->prefix . "users WHERE ID = %s LIMIT 1",  $user_id ));
  $table_name = $wpdb->prefix . "c5_history";
  //$wpdb->insert($table_name, array('description'=>"User <b>" . $user_data->display_name . "</b> reset password",'date'=>date('Y-m-d H:i:s'), 'plugin'=>'WordPress Core', 'user'=>$user_data->user_login));
}
*/